
# define TOKEN char
# define VALUE char*
# define STACKTOKENS 1
# define STACKSIZE 2048

# define BEGIN p_pbegin(self)
# define PRECC_Y /* signal to get precc's special V(x), T(x)  macros */
# include "cc.h"
# include "preccx.h"
# undef UNSETNAME
# include "preamble.h"

static
int p_pbegin(PRECC_DATA * self){
        static int passes; /* no. of times re-entered MAIN */
        int narg;          /* no of command line args */
        int nswitch;       /* count of command line switches */
        int switches;      /* flag - when doing command line switches */
        /*int dup2(int,int);*/
        
        if(passes++==0){   /* print motto */
                printf("\n\
/*    PRE-CC %d.%d compiler-compiler %s \n\
 *       Copyright Peter Breuer 1989-1998\n\
 *             <ptb@it.uc3m.es>\n\
 */\n\
",__PRECC__,__DATE__);
            call_mode=1;/* set no-auto shift in value stack */
            dup2(0,5);  /* save stdin and stdout */
            dup2(1,6);
            nswitch=0;  /* begin command line processing */
            switches=1;
            for (narg=1;narg<p_argc;narg++){
                switch(p_argv[narg][0]){
                case '-':
                    if(!switches) /* mixed switches and files */
                      usage (self,1);
                    nswitch++;
                    switch(p_argv[narg][1]){
                    case 'r': /* read buffer size in Kb */
                        getkintarg(self,p_argv[narg]+2,& self->readbuffersize,
                                   sizeof (TOKEN) + sizeof (VALUE));
                        break;
                    case 'p': /* internal program length in Kb */
                        getkintarg(self,p_argv[narg]+2,& self->maxprogramsize,
                                   sizeof (P_INSTRUCTION));
                        break;
                    case 'v': /* internal VALUE stack size in Kb */
                        getkintarg(self,p_argv[narg]+2,& self->stacksize,
                                   sizeof (P_STACKVALUE));
                        break;
                    case 'f': /* internal FRAME stack size in Kb */
                        getkintarg(self,p_argv[narg]+2,& self->contextstacksize,
                                   sizeof (P_FRAME));
                        break;
                    case 'c': /* internal stuff buffer size in Kb */
                        getkintarg(self,p_argv[narg]+2,&cbuffsize,
                                   sizeof (char));
                        break;
                    case 'n': /* internal name buffer size in Kb */
                        getkintarg(self,p_argv[narg]+2,&nbuffsize,
                                   sizeof (char));
                        break;
                    case 'o': 
                        if (0==strcmp(p_argv[narg]+1,"old"))
                            self->oldattributes=1;
                        else
                            self->oldattributes=0;
                        break;
                    default: /* unknown option */
                        usage(self,3);
                    }
                    break;
                default:
                    switches=0; /* end of switches */
                    break;
                }
            }                   /* now deal with redirects */
            p_infile = p_outfile = "-"; /* in and out file names */
            switch(p_argc-1-nswitch){
            case 2:
                    if (freopen(p_outfile=p_argv[nswitch+2], "w", stdout)==NULL) 
                      usage (self,2);
            case 1:
                    if (freopen(p_infile=p_argv[nswitch+1], "r", stdin)==NULL) 
                      usage (self,5);
            case 0: break;
            default: /* too many files named */
                    usage (self,6);
            }
            if (self->yylex != precc_yylex) {
               /* install our lexer */
               self->yylex = precc_yylex;
               self->yywrap = precc_yywrap;
               self->yytcharp = &precc_yytchar;
               self->yylinenop = &precc_yylineno;
               self->yylenp = &precc_yylen;
               self->yyllocp = &precc_yylloc;
               self->yylvalp = &precc_yylval;  
            }
	    {
	      VOID p_creat_data(PRECC_DATA*), p_destr_data(PRECC_DATA*);
	      /* remake data in case sizes have changed */
	      p_destr_data(self);
	      p_creat_data(self);
              p_creat_intern_data();
	    }
        }
        /* else passes > 0 */
        return 0;                /* success */
}

char *envs[PSTACKLENGTH];      /*environment stack*/
char *plvs[PSTACKLENGTH];      /*plainenv    stack*/
int  ecount=0;                 /*pointer */
int  countstack[PSTACKLENGTH]; /*stack of number of sequents we have seen */
int  countcount =0;            /*pointer */


void pushenv()
/* save the current environment and begin another */
{
    ecount++;
}

void popenv()
/* release the current env and recall the old */
{
    ecount--;
}

void pushcount()
/* save the current count of sequents and begin another */
{
    countcount++;
    /* the next line disambiguates references in blocks, but that is
     * probably not what is wanted.
     */
    /* count = countcount*PSTACKLENGTH + 1; */
    /* this next line does no disambiguation
     * and therefore causes warnings from C code,
     * but it doesn't matter.
     */
    count = 1;
}
void popcount()
/* release the current count of sequents and recall the old */
{
    countcount--;
}
int getcount()
/* return the current count level for sequents */
{
    return countcount;
}


                /* -- idens with params ------- */

static VOID hid0(PRECC_DATA* self) {
VV(2)=V(1);
}
static STATUS hid1(PRECC_DATA* self) {
PARSER rdbrktargs;ACTION hid0;
return p_attach0n(self,TOPARSER rdbrktargs,0,hid0,0);
}
static STATUS hid2(PRECC_DATA* self) {
PARSER hid1, p_nothing0;
return p_andparse0n (self,TOPARSER hid1,0,TOPARSER p_nothing0,0);
}
static STATUS hid3(PRECC_DATA* self) {
PARSER hid2;
return p_option0n(self,TOPARSER hid2,0);
}
static STATUS hid4(PRECC_DATA* self) {
PARSER IDENTIFIER, hid3;
return p_andparse0n (self,TOPARSER IDENTIFIER,0,TOPARSER hid3,0);
}
STATUS nameplusargs(PRECC_DATA* self) {
PARSER hid4;
P_RETURN((TOPARSER hid4)(self),"nameplusargs");
}

static VOID hid5(PRECC_DATA* self) {
VV(2)=V(1);
}
static STATUS hid6(PRECC_DATA* self) {
PARSER rdbrktvars;ACTION hid5;
return p_attach0n(self,TOPARSER rdbrktvars,0,hid5,0);
}
static STATUS hid7(PRECC_DATA* self) {
PARSER hid6, p_nothing0;
return p_andparse0n (self,TOPARSER hid6,0,TOPARSER p_nothing0,0);
}
static STATUS hid8(PRECC_DATA* self) {
PARSER hid7;
return p_option0n(self,TOPARSER hid7,0);
}
static STATUS hid9(PRECC_DATA* self) {
PARSER IDENTIFIER, hid8;
return p_andparse0n (self,TOPARSER IDENTIFIER,0,TOPARSER hid8,0);
}
STATUS nameplusvars(PRECC_DATA* self) {
PARSER hid9;
P_RETURN((TOPARSER hid9)(self),"nameplusvars");
}

/* someargs instead of theargs seems to cause a subtle bug with @a=)b[++c]=d( */

static STATUS hid10(PRECC_DATA* self) {
PARSER WHITESPACE, closebracket;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER closebracket,0);
}
static STATUS hid11(PRECC_DATA* self) {
PARSER theargs, hid10;
return p_andparse0n (self,TOPARSER theargs,0,TOPARSER hid10,0);
}
static STATUS hid12(PRECC_DATA* self) {
PARSER WHITESPACE, hid11;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid11,0);
}
static STATUS hid13(PRECC_DATA* self) {
PARSER openbracket, hid12;
return p_andparse0n (self,TOPARSER openbracket,0,TOPARSER hid12,0);
}
static VOID hid14(PRECC_DATA* self) {
VV(5)=V(3);
}
static STATUS hid15(PRECC_DATA* self) {
PARSER hid13;ACTION hid14;
return p_attach0n(self,TOPARSER hid13,0,hid14,0);
}
static STATUS hid16(PRECC_DATA* self) {
PARSER hid15, p_nothing0;
return p_andparse0n (self,TOPARSER hid15,0,TOPARSER p_nothing0,0);
}
STATUS sqbrktargs(PRECC_DATA* self) {
PARSER hid16;
P_RETURN((TOPARSER hid16)(self),"sqbrktargs");
}

static STATUS hid17(PRECC_DATA* self) {
PARSER WHITESPACE, closeparen;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER closeparen,0);
}
static STATUS hid18(PRECC_DATA* self) {
PARSER theargs, hid17;
return p_andparse0n (self,TOPARSER theargs,0,TOPARSER hid17,0);
}
static STATUS hid19(PRECC_DATA* self) {
PARSER WHITESPACE, hid18;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid18,0);
}
static STATUS hid20(PRECC_DATA* self) {
PARSER openparen, hid19;
return p_andparse0n (self,TOPARSER openparen,0,TOPARSER hid19,0);
}
static VOID hid21(PRECC_DATA* self) {
VV(5)=V(3);
}
static STATUS hid22(PRECC_DATA* self) {
PARSER hid20;ACTION hid21;
return p_attach0n(self,TOPARSER hid20,0,hid21,0);
}
static STATUS hid23(PRECC_DATA* self) {
PARSER hid22, p_nothing0;
return p_andparse0n (self,TOPARSER hid22,0,TOPARSER p_nothing0,0);
}
STATUS rdbrktargs(PRECC_DATA* self) {
PARSER hid23;
P_RETURN((TOPARSER hid23)(self),"rdbrktargs");
}

static STATUS hid24(PRECC_DATA* self) {
PARSER WHITESPACE, closeparen;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER closeparen,0);
}
static STATUS hid25(PRECC_DATA* self) {
PARSER thevars, hid24;
return p_andparse0n (self,TOPARSER thevars,0,TOPARSER hid24,0);
}
static STATUS hid26(PRECC_DATA* self) {
PARSER WHITESPACE, hid25;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid25,0);
}
static STATUS hid27(PRECC_DATA* self) {
PARSER openparen, hid26;
return p_andparse0n (self,TOPARSER openparen,0,TOPARSER hid26,0);
}
static VOID hid28(PRECC_DATA* self) {
VV(5)=V(3);
}
static STATUS hid29(PRECC_DATA* self) {
PARSER hid27;ACTION hid28;
return p_attach0n(self,TOPARSER hid27,0,hid28,0);
}
static STATUS hid30(PRECC_DATA* self) {
PARSER hid29, p_nothing0;
return p_andparse0n (self,TOPARSER hid29,0,TOPARSER p_nothing0,0);
}
STATUS rdbrktvars(PRECC_DATA* self) {
PARSER hid30;
P_RETURN((TOPARSER hid30)(self),"rdbrktvars");
}

/* these are token-driven writes */

static VOID hid31(PRECC_DATA* self) {
 VV(1) = putchar(T(1)); 
}
static STATUS hid32(PRECC_DATA* self) {
PARSER OPENPAREN;ACTION hid31;
return p_attach0n(self,TOPARSER OPENPAREN,0,hid31,0);
}
static STATUS hid33(PRECC_DATA* self) {
PARSER hid32, p_nothing0;
return p_andparse0n (self,TOPARSER hid32,0,TOPARSER p_nothing0,0);
}
STATUS openparen(PRECC_DATA* self) {
PARSER hid33;
P_RETURN((TOPARSER hid33)(self),"openparen");
}

static VOID hid34(PRECC_DATA* self) {
 VV(1) = putchar(T(1)); 
}
static STATUS hid35(PRECC_DATA* self) {
PARSER CLOSEPAREN;ACTION hid34;
return p_attach0n(self,TOPARSER CLOSEPAREN,0,hid34,0);
}
static STATUS hid36(PRECC_DATA* self) {
PARSER hid35, p_nothing0;
return p_andparse0n (self,TOPARSER hid35,0,TOPARSER p_nothing0,0);
}
STATUS closeparen(PRECC_DATA* self) {
PARSER hid36;
P_RETURN((TOPARSER hid36)(self),"closeparen");
}

static VOID hid37(PRECC_DATA* self) {
 VV(1) = putchar(T(1)); 
}
static STATUS hid38(PRECC_DATA* self) {
PARSER OPENBRACKET;ACTION hid37;
return p_attach0n(self,TOPARSER OPENBRACKET,0,hid37,0);
}
static STATUS hid39(PRECC_DATA* self) {
PARSER hid38, p_nothing0;
return p_andparse0n (self,TOPARSER hid38,0,TOPARSER p_nothing0,0);
}
STATUS openbracket(PRECC_DATA* self) {
PARSER hid39;
P_RETURN((TOPARSER hid39)(self),"openbracket");
}

static VOID hid40(PRECC_DATA* self) {
 VV(1) = putchar(T(1)); 
}
static STATUS hid41(PRECC_DATA* self) {
PARSER CLOSEBRACKET;ACTION hid40;
return p_attach0n(self,TOPARSER CLOSEBRACKET,0,hid40,0);
}
static STATUS hid42(PRECC_DATA* self) {
PARSER hid41, p_nothing0;
return p_andparse0n (self,TOPARSER hid41,0,TOPARSER p_nothing0,0);
}
STATUS closebracket(PRECC_DATA* self) {
PARSER hid42;
P_RETURN((TOPARSER hid42)(self),"closebracket");
}

static VOID hid43(PRECC_DATA* self) {
 VV(1) = putchar(T(1)); 
}
static STATUS hid44(PRECC_DATA* self) {
PARSER OPENBRACE;ACTION hid43;
return p_attach0n(self,TOPARSER OPENBRACE,0,hid43,0);
}
static STATUS hid45(PRECC_DATA* self) {
PARSER hid44, p_nothing0;
return p_andparse0n (self,TOPARSER hid44,0,TOPARSER p_nothing0,0);
}
STATUS openbrace(PRECC_DATA* self) {
PARSER hid45;
P_RETURN((TOPARSER hid45)(self),"openbrace");
}

static VOID hid46(PRECC_DATA* self) {
 VV(1) = putchar(T(1)); 
}
static STATUS hid47(PRECC_DATA* self) {
PARSER CLOSEBRACE;ACTION hid46;
return p_attach0n(self,TOPARSER CLOSEBRACE,0,hid46,0);
}
static STATUS hid48(PRECC_DATA* self) {
PARSER hid47, p_nothing0;
return p_andparse0n (self,TOPARSER hid47,0,TOPARSER p_nothing0,0);
}
STATUS closebrace(PRECC_DATA* self) {
PARSER hid48;
P_RETURN((TOPARSER hid48)(self),"closebrace");
}


static VOID hid49(PRECC_DATA* self) {
 VV(0)=""; 
}
static STATUS hid50(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid49;
return p_attach0n(self,TOPARSER p_nothing0,0,hid49,0);
}
static STATUS hid51(PRECC_DATA* self) {
PARSER hid50, p_nothing0;
return p_andparse0n (self,TOPARSER hid50,0,TOPARSER p_nothing0,0);
}
static STATUS hid52 (PRECC_DATA* self) {
PARSER someargs, hid51;
return p_orparse0n (self,TOPARSER someargs,0,TOPARSER hid51,0);
}
STATUS theargs(PRECC_DATA* self) {
PARSER hid52;
P_RETURN((TOPARSER hid52)(self),"theargs");
}

static VOID hid53(PRECC_DATA* self) {
 VV(0)=""; 
}
static STATUS hid54(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid53;
return p_attach0n(self,TOPARSER p_nothing0,0,hid53,0);
}
static STATUS hid55(PRECC_DATA* self) {
PARSER hid54, p_nothing0;
return p_andparse0n (self,TOPARSER hid54,0,TOPARSER p_nothing0,0);
}
static STATUS hid56 (PRECC_DATA* self) {
PARSER somevars, hid55;
return p_orparse0n (self,TOPARSER somevars,0,TOPARSER hid55,0);
}
STATUS thevars(PRECC_DATA* self) {
PARSER hid56;
P_RETURN((TOPARSER hid56)(self),"thevars");
}

static VOID hid57(PRECC_DATA* self) {
 VV(1)=putchar(','); 
}
static STATUS hid58(PRECC_DATA* self) {
PARSER COMMA;ACTION hid57;
return p_attach0n(self,TOPARSER COMMA,0,hid57,0);
}
static STATUS hid59(PRECC_DATA* self) {
PARSER hid58, p_nothing0;
return p_andparse0n (self,TOPARSER hid58,0,TOPARSER p_nothing0,0);
}
STATUS comma(PRECC_DATA* self) {
PARSER hid59;
P_RETURN((TOPARSER hid59)(self),"comma");
}

static STATUS hid60(PRECC_DATA* self) {
PARSER WHITESPACE, expr;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER expr,0);
}
static STATUS hid61(PRECC_DATA* self) {
PARSER comma, hid60;
return p_andparse0n (self,TOPARSER comma,0,TOPARSER hid60,0);
}
static STATUS hid62(PRECC_DATA* self) {
PARSER WHITESPACE, hid61;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid61,0);
}
static VOID hid63(PRECC_DATA* self) {
VV(5)=V(1);
}
static STATUS hid64(PRECC_DATA* self) {
PARSER hid62;ACTION hid63;
return p_attach0n(self,TOPARSER hid62,0,hid63,0);
}
static STATUS hid65(PRECC_DATA* self) {
PARSER hid64, p_nothing0;
return p_andparse0n (self,TOPARSER hid64,0,TOPARSER p_nothing0,0);
}
static STATUS hid66(PRECC_DATA* self) {
PARSER hid65;
return p_many0n(self,TOPARSER hid65,0);
}
static STATUS hid67(PRECC_DATA* self) {
PARSER expr, hid66;
return p_andparse0n (self,TOPARSER expr,0,TOPARSER hid66,0);
}
STATUS someargs(PRECC_DATA* self) {
PARSER hid67;
P_RETURN((TOPARSER hid67)(self),"someargs");
}


static STATUS hid68(PRECC_DATA* self) {
PARSER WHITESPACE, var;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER var,0);
}
static STATUS hid69(PRECC_DATA* self) {
PARSER comma, hid68;
return p_andparse0n (self,TOPARSER comma,0,TOPARSER hid68,0);
}
static STATUS hid70(PRECC_DATA* self) {
PARSER WHITESPACE, hid69;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid69,0);
}
static VOID hid71(PRECC_DATA* self) {
VV(5)=V(1);
}
static STATUS hid72(PRECC_DATA* self) {
PARSER hid70;ACTION hid71;
return p_attach0n(self,TOPARSER hid70,0,hid71,0);
}
static STATUS hid73(PRECC_DATA* self) {
PARSER hid72, p_nothing0;
return p_andparse0n (self,TOPARSER hid72,0,TOPARSER p_nothing0,0);
}
static STATUS hid74(PRECC_DATA* self) {
PARSER hid73;
return p_many0n(self,TOPARSER hid73,0);
}
static STATUS hid75(PRECC_DATA* self) {
PARSER var, hid74;
return p_andparse0n (self,TOPARSER var,0,TOPARSER hid74,0);
}
STATUS somevars(PRECC_DATA* self) {
PARSER hid75;
P_RETURN((TOPARSER hid75)(self),"somevars");
}


static VOID hid76(PRECC_DATA* self) {
if(*putargs(""))putargs(",");putargs("PARAM ");putargs(V(1));
                 if(*putmeta(""))putmeta(",");putmeta(V(1));
}
static STATUS hid77(PRECC_DATA* self) {
PARSER IDENTIFIER;ACTION hid76;
return p_attach0n(self,TOPARSER IDENTIFIER,0,hid76,0);
}
static STATUS hid78(PRECC_DATA* self) {
PARSER hid77, p_nothing0;
return p_andparse0n (self,TOPARSER hid77,0,TOPARSER p_nothing0,0);
}
STATUS var(PRECC_DATA* self) {
PARSER hid78;
P_RETURN((TOPARSER hid78)(self),"var");
}


                /* -- parser identifiers --- */

/* collect IDENTIFIERs from buffers */

void SETENV()
/* seal the current environment to be whats in the buffers now */
{
  environment=putargs("");
  plainenv=putmeta("");
  getargs(&environment);
  getmeta(&plainenv);
}

char *LASTVAR()
/* last variable in the current environment */
{
char *s;
if (ecount<0)
  return (char*)NULL;
s = strchr(plainenv,',');
if (!s)
  return plainenv;
return s+1;
}

/* first item written in a declaration block */
static VOID hid79(PRECC_DATA* self) {
getname(&V(1));SETENV();
}
static STATUS hid80(PRECC_DATA* self) {
PARSER nameplusvars;ACTION hid79;
return p_attach0n(self,TOPARSER nameplusvars,0,hid79,0);
}
static STATUS hid81(PRECC_DATA* self) {
PARSER hid80, p_nothing0;
return p_andparse0n (self,TOPARSER hid80,0,TOPARSER p_nothing0,0);
}
STATUS declname(PRECC_DATA* self) {
PARSER hid81;
P_RETURN((TOPARSER hid81)(self),"declname");
}

/* to make #line references to definitions immediately before the
   FIRST STATUS foo line in the emitted code, insert P_LINE; before the
   getname above */


/* collect a domain IDENTIFIER in the same way */

static VOID hid82(PRECC_DATA* self) {
getname(&V(1));
}
static STATUS hid83(PRECC_DATA* self) {
PARSER nameplusargs;ACTION hid82;
return p_attach0n(self,TOPARSER nameplusargs,0,hid82,0);
}
static STATUS hid84(PRECC_DATA* self) {
PARSER hid83, p_nothing0;
return p_andparse0n (self,TOPARSER hid83,0,TOPARSER p_nothing0,0);
}
STATUS exprname(PRECC_DATA* self) {
PARSER hid84;
P_RETURN((TOPARSER hid84)(self),"exprname");
}


                /* -- start of precc defn ----   */


static STATUS hid85(PRECC_DATA* self) {
PARSER declerr;
return p_uerror0n(self,TOPARSER declerr,0);
}
static STATUS hid86(PRECC_DATA* self) {
PARSER expression, WHITESPACE;
return p_andparse0n (self,TOPARSER expression,0,TOPARSER WHITESPACE,0);
}
static STATUS hid87(PRECC_DATA* self) {
PARSER WHITESPACE, hid86;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid86,0);
}
static STATUS hid88(PRECC_DATA* self) {
PARSER EQUALS, hid87;
return p_andparse0n (self,TOPARSER EQUALS,0,TOPARSER hid87,0);
}
static STATUS hid89(PRECC_DATA* self) {
PARSER WHITESPACE, hid88;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid88,0);
}
static STATUS hid90(PRECC_DATA* self) {
PARSER declname, hid89;
return p_andparse0n (self,TOPARSER declname,0,TOPARSER hid89,0);
}
static STATUS hid91(PRECC_DATA* self) {
PARSER WHITESPACE, hid90;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid90,0);
}
static STATUS hid92(PRECC_DATA* self) {
PARSER hid85, hid91;
return p_andparse0n (self,TOPARSER hid85,0,TOPARSER hid91,0);
}
static STATUS hid93(PRECC_DATA* self) {
PARSER AT, hid92;
return p_andparse0n (self,TOPARSER AT,0,TOPARSER hid92,0);
}
static STATUS hid94(PRECC_DATA* self) {
PARSER p_first0, hid93;
return p_andparse0n (self,TOPARSER p_first0,0,TOPARSER hid93,0);
}
static VOID hid95(PRECC_DATA* self) {
VV(10) = P_REN(V(5),V(9));countcount=0;RESET;
}
static STATUS hid96(PRECC_DATA* self) {
PARSER hid94;ACTION hid95;
return p_attach0n(self,TOPARSER hid94,0,hid95,0);
}
static STATUS hid97(PRECC_DATA* self) {
PARSER hid96, p_nothing0;
return p_andparse0n (self,TOPARSER hid96,0,TOPARSER p_nothing0,0);
}
STATUS declaration(PRECC_DATA* self) {
PARSER hid97;
P_RETURN((TOPARSER hid97)(self),"declaration");
}

void ADDVAR(char *x)
/* make a new environment with one more var. save the old. */
{
  char *n;
                 /* finish off current env */
  getargs(&n);
  getmeta(&n);
                 /* copy old to new - start by buffering it */
  putargs(environment);
  putmeta(plainenv);
                 /* increment env count */
  pushenv();
                 /* point env at buffer */
  environment=putargs("");
  plainenv=putmeta("");
                 /* add new var */

  if (is_in(x,plainenv))
      return;    /* unless already there */

  if(*environment){
    putargs(",");
    putmeta(",");
  }
  putargs("VALUE ");  /* this is a special kind of new variable */
  putargs(x);
  putmeta(x);
                 /* note that the buffer is still unterminated */
}



/* to make #line references to definitions immediately before the
   STATUS foo line in the emitted code, insert P_LINE; before the
   VV above */

static STATUS hid98(PRECC_DATA* self) {
PARSER printdeclerr, passthrough;
return p_andparse0n (self,TOPARSER printdeclerr,0,TOPARSER passthrough,0);
}
static VOID hid99(PRECC_DATA* self) {
VV(2)=V(1);
}
static STATUS hid100(PRECC_DATA* self) {
PARSER hid98;ACTION hid99;
return p_attach0n(self,TOPARSER hid98,0,hid99,0);
}
static STATUS hid101(PRECC_DATA* self) {
PARSER hid100, p_nothing0;
return p_andparse0n (self,TOPARSER hid100,0,TOPARSER p_nothing0,0);
}
STATUS declerr(PRECC_DATA* self) {
PARSER hid101;
P_RETURN((TOPARSER hid101)(self),"declerr");
}

static VOID hid102(PRECC_DATA* self) {
VV(0)="@";
                 fprintf(stderr,"line %d error: malformed declaration\n@?",*self->yylinenop); 
}
static STATUS hid103(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid102;
return p_attach0n(self,TOPARSER p_nothing0,0,hid102,0);
}
static STATUS hid104(PRECC_DATA* self) {
PARSER hid103, p_nothing0;
return p_andparse0n (self,TOPARSER hid103,0,TOPARSER p_nothing0,0);
}
STATUS printdeclerr(PRECC_DATA* self) {
PARSER hid104;
P_RETURN((TOPARSER hid104)(self),"printdeclerr");
}

                /* that was it. Now the top level (MAIN) parse. */

static STATUS hid105(PRECC_DATA* self) {
PARSER notanat, passthrough;
return p_andparse0n (self,TOPARSER notanat,0,TOPARSER passthrough,0);
}
static VOID hid106(PRECC_DATA* self) {
VV(0)="";printf("\n");
}
static STATUS hid107(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid106;
return p_attach0n(self,TOPARSER p_nothing0,0,hid106,0);
}
static STATUS hid108(PRECC_DATA* self) {
PARSER hid107, p_nothing0;
return p_andparse0n (self,TOPARSER hid107,0,TOPARSER p_nothing0,0);
}
static STATUS hid109 (PRECC_DATA* self) {
PARSER hid105, hid108;
return p_orparse0n (self,TOPARSER hid105,0,TOPARSER hid108,0);
}
static STATUS hid110 (PRECC_DATA* self) {
PARSER declaration, hid109;
return p_orparse0n (self,TOPARSER declaration,0,TOPARSER hid109,0);
}
STATUS line(PRECC_DATA* self) {
PARSER hid110;
P_RETURN((TOPARSER hid110)(self),"line");
}

static VOID hid111(PRECC_DATA* self) {
 VV(1)=putchar(T(1)); 
}
static STATUS hid112(PRECC_DATA* self) {
PARSER NOTANAT;ACTION hid111;
return p_attach0n(self,TOPARSER NOTANAT,0,hid111,0);
}
static STATUS hid113(PRECC_DATA* self) {
PARSER hid112, p_nothing0;
return p_andparse0n (self,TOPARSER hid112,0,TOPARSER p_nothing0,0);
}
STATUS notanat(PRECC_DATA* self) {
PARSER hid113;
P_RETURN((TOPARSER hid113)(self),"notanat");
}

/* this is a deliberate pop of the value 'behind'  if we get none */

static VOID hid114(PRECC_DATA* self) {
 VV(2)=V(1); 
}
static STATUS hid115(PRECC_DATA* self) {
PARSER anychar;ACTION hid114;
return p_attach0n(self,TOPARSER anychar,0,hid114,0);
}
static STATUS hid116(PRECC_DATA* self) {
PARSER hid115, p_nothing0;
return p_andparse0n (self,TOPARSER hid115,0,TOPARSER p_nothing0,0);
}
static STATUS hid117(PRECC_DATA* self) {
PARSER hid116;
return p_many0n(self,TOPARSER hid116,0);
}
static VOID hid118(PRECC_DATA* self) {
getname(&V(1));printf("%s\n",V(1)); RESET;
}
static STATUS hid119(PRECC_DATA* self) {
PARSER hid117;ACTION hid118;
return p_attach0n(self,TOPARSER hid117,0,hid118,0);
}
static STATUS hid120(PRECC_DATA* self) {
PARSER hid119, p_nothing0;
return p_andparse0n (self,TOPARSER hid119,0,TOPARSER p_nothing0,0);
}
STATUS passthrough(PRECC_DATA* self) {
PARSER hid120;
P_RETURN((TOPARSER hid120)(self),"passthrough");
}

static VOID hid121(PRECC_DATA* self) {
 VV(1)=putchar(T(1)); 
}
static STATUS hid122(PRECC_DATA* self) {
PARSER ANYTHING;ACTION hid121;
return p_attach0n(self,TOPARSER ANYTHING,0,hid121,0);
}
static STATUS hid123(PRECC_DATA* self) {
PARSER hid122, p_nothing0;
return p_andparse0n (self,TOPARSER hid122,0,TOPARSER p_nothing0,0);
}
STATUS anychar(PRECC_DATA* self) {
PARSER hid123;
P_RETURN((TOPARSER hid123)(self),"anychar");
}

                /* ----  parser expressions -------- */

static STATUS hid124 (PRECC_DATA* self) {
PARSER alternates, empty;
return p_orparse0n (self,TOPARSER alternates,0,TOPARSER empty,0);
}
STATUS expression(PRECC_DATA* self) {
PARSER hid124;
P_RETURN((TOPARSER hid124)(self),"expression");
}

/* a <'|'> separated series, at least one <'|'>  - note the overpull 
   I prefer the order which results from recursion */

static STATUS hid125(PRECC_DATA* self) {
PARSER WHITESPACE, alternates;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER alternates,0);
}
static STATUS hid126(PRECC_DATA* self) {
PARSER OR, hid125;
return p_andparse0n (self,TOPARSER OR,0,TOPARSER hid125,0);
}
static STATUS hid127(PRECC_DATA* self) {
PARSER WHITESPACE, hid126;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid126,0);
}
static VOID hid128(PRECC_DATA* self) {
char *n;
                 VV(5)=(GETNEWNAME(&n,plainenv),P_ALT(n,V(1),V(5)));
}
static STATUS hid129(PRECC_DATA* self) {
PARSER hid127;ACTION hid128;
return p_attach0n(self,TOPARSER hid127,0,hid128,0);
}
static STATUS hid130(PRECC_DATA* self) {
PARSER hid129, p_nothing0;
return p_andparse0n (self,TOPARSER hid129,0,TOPARSER p_nothing0,0);
}
static STATUS hid131(PRECC_DATA* self) {
PARSER hid130;
return p_option0n(self,TOPARSER hid130,0);
}
static STATUS hid132(PRECC_DATA* self) {
PARSER sequence, hid131;
return p_andparse0n (self,TOPARSER sequence,0,TOPARSER hid131,0);
}
STATUS alternates(PRECC_DATA* self) {
PARSER hid132;
P_RETURN((TOPARSER hid132)(self),"alternates");
}

/* appending is much more efficient than prepending because I don't waste
  C-stack space with MARK before a parse */

/* this is a command separated sequence of sequents which are not commands
*/

static STATUS hid133(PRECC_DATA* self) {
PARSER WHITESPACE, manysequents;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER manysequents,0);
}
static STATUS hid134(PRECC_DATA* self) {
PARSER command, hid133;
return p_andparse0n (self,TOPARSER command,0,TOPARSER hid133,0);
}
static STATUS hid135(PRECC_DATA* self) {
PARSER WHITESPACE, hid134;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid134,0);
}
static VOID hid136(PRECC_DATA* self) {
char *n;
                  VV(3)=(GETNEWNAME(&n,plainenv),P_AND(n,V(1),V(3)));
}
static STATUS hid137(PRECC_DATA* self) {
PARSER hid135;ACTION hid136;
return p_attach0n(self,TOPARSER hid135,0,hid136,0);
}
static STATUS hid138(PRECC_DATA* self) {
PARSER hid137, p_nothing0;
return p_andparse0n (self,TOPARSER hid137,0,TOPARSER p_nothing0,0);
}
static STATUS hid139(PRECC_DATA* self) {
PARSER hid138;
return p_many0n(self,TOPARSER hid138,0);
}
static STATUS hid140(PRECC_DATA* self) {
PARSER WHITESPACE, command;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER command,0);
}
static STATUS hid141(PRECC_DATA* self) {
PARSER hid140;
return p_option0n(self,TOPARSER hid140,0);
}
static STATUS hid142(PRECC_DATA* self) {
PARSER hid139, hid141;
return p_andparse0n (self,TOPARSER hid139,0,TOPARSER hid141,0);
}
static STATUS hid143(PRECC_DATA* self) {
PARSER manysequents, hid142;
return p_andparse0n (self,TOPARSER manysequents,0,TOPARSER hid142,0);
}
STATUS sequence(PRECC_DATA* self) {
PARSER hid143;
P_RETURN((TOPARSER hid143)(self),"sequence");
}

 /* here we attach to the manysequents which this follows */

static STATUS hid144(PRECC_DATA* self) {
PARSER c_code, COLONorEOL;
return p_andparse0n (self,TOPARSER c_code,0,TOPARSER COLONorEOL,0);
}
static STATUS hid145(PRECC_DATA* self) {
PARSER COLON, hid144;
return p_andparse0n (self,TOPARSER COLON,0,TOPARSER hid144,0);
}
static VOID hid146(PRECC_DATA* self) {
 char *n,*m;
             VV(5)=(GETNEWNAME(&n,plainenv),GETNEWNAME(&m,plainenv),P_ATT(m,V(1),n,V(4))); 
}
static STATUS hid147(PRECC_DATA* self) {
PARSER hid145;ACTION hid146;
return p_attach0n(self,TOPARSER hid145,0,hid146,0);
}
static STATUS hid148(PRECC_DATA* self) {
PARSER hid147, p_nothing0;
return p_andparse0n (self,TOPARSER hid147,0,TOPARSER p_nothing0,0);
}
STATUS command(PRECC_DATA* self) {
PARSER hid148;
P_RETURN((TOPARSER hid148)(self),"command");
}

static STATUS hid149(PRECC_DATA* self) {
PARSER COLON, CLOSEBRACE;
return p_andparse0n (self,TOPARSER COLON,0,TOPARSER CLOSEBRACE,0);
}
static STATUS hid150(PRECC_DATA* self) {
PARSER c_code1, hid149;
return p_andparse0n (self,TOPARSER c_code1,0,TOPARSER hid149,0);
}
static STATUS hid151(PRECC_DATA* self) {
PARSER COLON, hid150;
return p_andparse0n (self,TOPARSER COLON,0,TOPARSER hid150,0);
}
static STATUS hid152(PRECC_DATA* self) {
PARSER OPENBRACE, hid151;
return p_andparse0n (self,TOPARSER OPENBRACE,0,TOPARSER hid151,0);
}
static VOID hid153(PRECC_DATA* self) {
 char *n,*m;
             VV(5)=(GETNEWNAME(&n,plainenv),GETNEWNAME(&m,plainenv),P_ATT(m,"p_nothing0",n,V(3))); 
}
static STATUS hid154(PRECC_DATA* self) {
PARSER hid152;ACTION hid153;
return p_attach0n(self,TOPARSER hid152,0,hid153,0);
}
static STATUS hid155(PRECC_DATA* self) {
PARSER hid154, p_nothing0;
return p_andparse0n (self,TOPARSER hid154,0,TOPARSER p_nothing0,0);
}
static STATUS hid156(PRECC_DATA* self) {
PARSER CLOSEBRACE, COLON;
return p_andparse0n (self,TOPARSER CLOSEBRACE,0,TOPARSER COLON,0);
}
static STATUS hid157(PRECC_DATA* self) {
PARSER c_code2, hid156;
return p_andparse0n (self,TOPARSER c_code2,0,TOPARSER hid156,0);
}
static STATUS hid158(PRECC_DATA* self) {
PARSER OPENBRACE, hid157;
return p_andparse0n (self,TOPARSER OPENBRACE,0,TOPARSER hid157,0);
}
static STATUS hid159(PRECC_DATA* self) {
PARSER COLON, hid158;
return p_andparse0n (self,TOPARSER COLON,0,TOPARSER hid158,0);
}
static VOID hid160(PRECC_DATA* self) {
 char *n,*m;
             VV(5)=(GETNEWNAME(&n,plainenv),GETNEWNAME(&m,plainenv),P_ATT(m,"p_nothing0",n,V(3))); 
}
static STATUS hid161(PRECC_DATA* self) {
PARSER hid159;ACTION hid160;
return p_attach0n(self,TOPARSER hid159,0,hid160,0);
}
static STATUS hid162(PRECC_DATA* self) {
PARSER hid161, p_nothing0;
return p_andparse0n (self,TOPARSER hid161,0,TOPARSER p_nothing0,0);
}
static STATUS hid163 (PRECC_DATA* self) {
PARSER hid155, hid162;
return p_orparse0n (self,TOPARSER hid155,0,TOPARSER hid162,0);
}
STATUS bracketcommand(PRECC_DATA* self) {
PARSER hid163;
P_RETURN((TOPARSER hid163)(self),"bracketcommand");
}

/* manysequents is a 0 or more long list of nonempty non-commands */

/* start a new count */

/* do the pulling in moresequents, if it happens */

static STATUS hid164(PRECC_DATA* self) {
PARSER moresequents;
return p_option0n(self,TOPARSER moresequents,0);
}
static STATUS hid165(PRECC_DATA* self) {
PARSER firstsequent, hid164;
return p_andparse0n (self,TOPARSER firstsequent,0,TOPARSER hid164,0);
}
static VOID hid166(PRECC_DATA* self) {
 popcount();
}
static STATUS hid167(PRECC_DATA* self) {
PARSER hid165;ACTION hid166;
return p_attach0n(self,TOPARSER hid165,0,hid166,0);
}
static STATUS hid168(PRECC_DATA* self) {
PARSER hid167, p_nothing0;
return p_andparse0n (self,TOPARSER hid167,0,TOPARSER p_nothing0,0);
}
STATUS manysequents(PRECC_DATA* self) {
PARSER hid168;
P_RETURN((TOPARSER hid168)(self),"manysequents");
}

/* need "empty newvar empty" and "sequent newvar empty" to make the
   above complete, but it's too much bother right now */

static STATUS hid169 (PRECC_DATA* self) {
PARSER sequent, empty;
return p_orparse0n (self,TOPARSER sequent,0,TOPARSER empty,0);
}
static VOID hid170(PRECC_DATA* self) {
pushcount();
}
static STATUS hid171(PRECC_DATA* self) {
PARSER hid169;ACTION hid170;
return p_attach0n(self,TOPARSER hid169,0,hid170,0);
}
static STATUS hid172(PRECC_DATA* self) {
PARSER hid171, p_nothing0;
return p_andparse0n (self,TOPARSER hid171,0,TOPARSER p_nothing0,0);
}
STATUS firstsequent(PRECC_DATA* self) {
PARSER hid172;
P_RETURN((TOPARSER hid172)(self),"firstsequent");
}


        /* overpull again in the option 
           again, I prefer to use recursion for better output order */

/* without a parameterized spec, I can't prevent repetitions */

static STATUS hid173(PRECC_DATA* self) {
PARSER BACKSLASH, IDENTIFIER;
return p_andparse0n (self,TOPARSER BACKSLASH,0,TOPARSER IDENTIFIER,0);
}
static VOID hid174(PRECC_DATA* self) {
VV(2)=V(2);getname(&V(2));ADDVAR(V(2));
}
static STATUS hid175(PRECC_DATA* self) {
PARSER hid173;ACTION hid174;
return p_attach0n(self,TOPARSER hid173,0,hid174,0);
}
static STATUS hid176(PRECC_DATA* self) {
PARSER hid175, p_nothing0;
return p_andparse0n (self,TOPARSER hid175,0,TOPARSER p_nothing0,0);
}
STATUS newvar(PRECC_DATA* self) {
PARSER hid176;
P_RETURN((TOPARSER hid176)(self),"newvar");
}

/* moresequents is a 1 or more long list of sequents, or an attr decl
 * followed by a 1 or more long list. It is not empty. It is not
 * (presently) a newvar on its own, though it might eventually be */

static STATUS hid177(PRECC_DATA* self) {
PARSER moresequents;
return p_option0n(self,TOPARSER moresequents,0);
}
static STATUS hid178(PRECC_DATA* self) {
PARSER sequent, hid177;
return p_andparse0n (self,TOPARSER sequent,0,TOPARSER hid177,0);
}
static STATUS hid179(PRECC_DATA* self) {
PARSER WHITESPACE, hid178;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid178,0);
}
static STATUS hid180(PRECC_DATA* self) {
PARSER newvar, hid179;
return p_andparse0n (self,TOPARSER newvar,0,TOPARSER hid179,0);
}
static VOID hid181(PRECC_DATA* self) {
 char *n; VV(4)=V(1);popenv();
          GETNEWNAME(&n,plainenv);V(1)=P_STAR(n,V(1),V(4),V(2));
}
static STATUS hid182(PRECC_DATA* self) {
PARSER hid180;ACTION hid181;
return p_attach0n(self,TOPARSER hid180,0,hid181,0);
}
static STATUS hid183(PRECC_DATA* self) {
PARSER hid182, p_nothing0;
return p_andparse0n (self,TOPARSER hid182,0,TOPARSER p_nothing0,0);
}
static STATUS hid184(PRECC_DATA* self) {
PARSER moresequents;
return p_option0n(self,TOPARSER moresequents,0);
}
static STATUS hid185(PRECC_DATA* self) {
PARSER sequent, hid184;
return p_andparse0n (self,TOPARSER sequent,0,TOPARSER hid184,0);
}
static STATUS hid186(PRECC_DATA* self) {
PARSER WHITESPACE, hid185;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid185,0);
}
static STATUS hid187(PRECC_DATA* self) {
PARSER dummyvar, hid186;
return p_andparse0n (self,TOPARSER dummyvar,0,TOPARSER hid186,0);
}
static VOID hid188(PRECC_DATA* self) {
 char *n; VV(4)=V(1);
          if (self->oldattributes){popenv();
          GETNEWNAME(&n,plainenv);V(1)=P_STAR(n,V(1),V(4),V(2));}
          else{
          GETNEWNAME(&n,plainenv);V(1)=P_AND(n,V(1),V(4));}
}
static STATUS hid189(PRECC_DATA* self) {
PARSER hid187;ACTION hid188;
return p_attach0n(self,TOPARSER hid187,0,hid188,0);
}
static STATUS hid190(PRECC_DATA* self) {
PARSER hid189, p_nothing0;
return p_andparse0n (self,TOPARSER hid189,0,TOPARSER p_nothing0,0);
}
static STATUS hid191 (PRECC_DATA* self) {
PARSER hid183, hid190;
return p_orparse0n (self,TOPARSER hid183,0,TOPARSER hid190,0);
}
STATUS moresequents(PRECC_DATA* self) {
PARSER hid191;
P_RETURN((TOPARSER hid191)(self),"moresequents");
}

/* in the above, have to be careful to avoid allowing a trailing "empty"
   because that wrecks the returned value from an @foo@ */

static VOID hid192(PRECC_DATA* self) {
/*empty*/ VV(0)=V(1);
             if(self->oldattributes){
             getname(&V(1));
             GETANAME(&V(1),"p_","",count++);
             V(1)=GNAME(V(1));putname(V(1));
             getname(&V(1));
             ADDVAR(V(1)); }
}
static STATUS hid193(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid192;
return p_attach0n(self,TOPARSER p_nothing0,0,hid192,0);
}
static STATUS hid194(PRECC_DATA* self) {
PARSER hid193, p_nothing0;
return p_andparse0n (self,TOPARSER hid193,0,TOPARSER p_nothing0,0);
}
STATUS dummyvar(PRECC_DATA* self) {
PARSER hid194;
P_RETURN((TOPARSER hid194)(self),"dummyvar");
}
        /* Don't overpull now because ... */

static STATUS hid195(PRECC_DATA* self) {
PARSER postfix;
return p_option0n(self,TOPARSER postfix,0);
}
static STATUS hid196(PRECC_DATA* self) {
PARSER seqoperand, hid195;
return p_andparse0n (self,TOPARSER seqoperand,0,TOPARSER hid195,0);
}
STATUS sequent(PRECC_DATA* self) {
PARSER hid196;
P_RETURN((TOPARSER hid196)(self),"sequent");
}

        /* in each of these cases the postfix must behave as though the
        seqoperand were before it and overpull its arguments and write into
        the stack position to the left of itself */


static STATUS hid197 (PRECC_DATA* self) {
PARSER plusop, hideop;
return p_orparse0n (self,TOPARSER plusop,0,TOPARSER hideop,0);
}
static STATUS hid198 (PRECC_DATA* self) {
PARSER starop, hid197;
return p_orparse0n (self,TOPARSER starop,0,TOPARSER hid197,0);
}
STATUS postfix(PRECC_DATA* self) {
PARSER hid198;
P_RETURN((TOPARSER hid198)(self),"postfix");
}

static STATUS hid199(PRECC_DATA* self) {
PARSER WHITESPACE, CLOSEBRACE;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER CLOSEBRACE,0);
}
static STATUS hid200(PRECC_DATA* self) {
PARSER expression, hid199;
return p_andparse0n (self,TOPARSER expression,0,TOPARSER hid199,0);
}
static STATUS hid201(PRECC_DATA* self) {
PARSER WHITESPACE, hid200;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid200,0);
}
static STATUS hid202(PRECC_DATA* self) {
PARSER OPENBRACE, hid201;
return p_andparse0n (self,TOPARSER OPENBRACE,0,TOPARSER hid201,0);
}
static VOID hid203(PRECC_DATA* self) {
 VV(5) = V(3); 
}
static STATUS hid204(PRECC_DATA* self) {
PARSER hid202;ACTION hid203;
return p_attach0n(self,TOPARSER hid202,0,hid203,0);
}
static STATUS hid205(PRECC_DATA* self) {
PARSER hid204, p_nothing0;
return p_andparse0n (self,TOPARSER hid204,0,TOPARSER p_nothing0,0);
}
STATUS bracket(PRECC_DATA* self) {
PARSER hid205;
P_RETURN((TOPARSER hid205)(self),"bracket");
}

static STATUS hid206(PRECC_DATA* self) {
PARSER WHITESPACE, CLOSEBRACKET;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER CLOSEBRACKET,0);
}
static STATUS hid207(PRECC_DATA* self) {
PARSER expression, hid206;
return p_andparse0n (self,TOPARSER expression,0,TOPARSER hid206,0);
}
static STATUS hid208(PRECC_DATA* self) {
PARSER WHITESPACE, hid207;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid207,0);
}
static STATUS hid209(PRECC_DATA* self) {
PARSER OPENBRACKET, hid208;
return p_andparse0n (self,TOPARSER OPENBRACKET,0,TOPARSER hid208,0);
}
static VOID hid210(PRECC_DATA* self) {
 char *n;VV(5)=(GETNEWNAME(&n,plainenv),P_OPT(n,V(3))); 
}
static STATUS hid211(PRECC_DATA* self) {
PARSER hid209;ACTION hid210;
return p_attach0n(self,TOPARSER hid209,0,hid210,0);
}
static STATUS hid212(PRECC_DATA* self) {
PARSER hid211, p_nothing0;
return p_andparse0n (self,TOPARSER hid211,0,TOPARSER p_nothing0,0);
}
STATUS option(PRECC_DATA* self) {
PARSER hid212;
P_RETURN((TOPARSER hid212)(self),"option");
}

static VOID hid213(PRECC_DATA* self) {
 VV(0)= "p_nothing0"; 
}
static STATUS hid214(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid213;
return p_attach0n(self,TOPARSER p_nothing0,0,hid213,0);
}
static STATUS hid215(PRECC_DATA* self) {
PARSER hid214, p_nothing0;
return p_andparse0n (self,TOPARSER hid214,0,TOPARSER p_nothing0,0);
}
STATUS empty(PRECC_DATA* self) {
PARSER hid215;
P_RETURN((TOPARSER hid215)(self),"empty");
}


static STATUS hid216(PRECC_DATA* self) {
PARSER WHITESPACE, AT;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER AT,0);
}
static STATUS hid217(PRECC_DATA* self) {
PARSER expr, hid216;
return p_andparse0n (self,TOPARSER expr,0,TOPARSER hid216,0);
}
static STATUS hid218(PRECC_DATA* self) {
PARSER WHITESPACE, hid217;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid217,0);
}
static STATUS hid219(PRECC_DATA* self) {
PARSER AT, hid218;
return p_andparse0n (self,TOPARSER AT,0,TOPARSER hid218,0);
}
static VOID hid220(PRECC_DATA* self) {
char *n; VV(5)=(getname(&V(3)),
                  GETNEWNAME(&n,plainenv),P_ATA(n,V(3))); 
}
static STATUS hid221(PRECC_DATA* self) {
PARSER hid219;ACTION hid220;
return p_attach0n(self,TOPARSER hid219,0,hid220,0);
}
static STATUS hid222(PRECC_DATA* self) {
PARSER hid221, p_nothing0;
return p_andparse0n (self,TOPARSER hid221,0,TOPARSER p_nothing0,0);
}
STATUS result(PRECC_DATA* self) {
PARSER hid222;
P_RETURN((TOPARSER hid222)(self),"result");
}

static STATUS hid223(PRECC_DATA* self) {
PARSER AT, CLOSEBRACE;
return p_andparse0n (self,TOPARSER AT,0,TOPARSER CLOSEBRACE,0);
}
static STATUS hid224(PRECC_DATA* self) {
PARSER WHITESPACE, hid223;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid223,0);
}
static STATUS hid225(PRECC_DATA* self) {
PARSER atstuffs, hid224;
return p_andparse0n (self,TOPARSER atstuffs,0,TOPARSER hid224,0);
}
static STATUS hid226(PRECC_DATA* self) {
PARSER WHITESPACE, hid225;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid225,0);
}
static STATUS hid227(PRECC_DATA* self) {
PARSER AT, hid226;
return p_andparse0n (self,TOPARSER AT,0,TOPARSER hid226,0);
}
static STATUS hid228(PRECC_DATA* self) {
PARSER OPENBRACE, hid227;
return p_andparse0n (self,TOPARSER OPENBRACE,0,TOPARSER hid227,0);
}
static VOID hid229(PRECC_DATA* self) {
char *n; VV(7)=(getname(&V(4)),
                  GETNEWNAME(&n,plainenv),P_ATA(n,V(4))); 
}
static STATUS hid230(PRECC_DATA* self) {
PARSER hid228;ACTION hid229;
return p_attach0n(self,TOPARSER hid228,0,hid229,0);
}
static STATUS hid231(PRECC_DATA* self) {
PARSER hid230, p_nothing0;
return p_andparse0n (self,TOPARSER hid230,0,TOPARSER p_nothing0,0);
}
static STATUS hid232(PRECC_DATA* self) {
PARSER CLOSEBRACE, AT;
return p_andparse0n (self,TOPARSER CLOSEBRACE,0,TOPARSER AT,0);
}
static STATUS hid233(PRECC_DATA* self) {
PARSER WHITESPACE, hid232;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid232,0);
}
static STATUS hid234(PRECC_DATA* self) {
PARSER aatstuffs, hid233;
return p_andparse0n (self,TOPARSER aatstuffs,0,TOPARSER hid233,0);
}
static STATUS hid235(PRECC_DATA* self) {
PARSER WHITESPACE, hid234;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid234,0);
}
static STATUS hid236(PRECC_DATA* self) {
PARSER OPENBRACE, hid235;
return p_andparse0n (self,TOPARSER OPENBRACE,0,TOPARSER hid235,0);
}
static STATUS hid237(PRECC_DATA* self) {
PARSER AT, hid236;
return p_andparse0n (self,TOPARSER AT,0,TOPARSER hid236,0);
}
static VOID hid238(PRECC_DATA* self) {
char *n; VV(7)=(getname(&V(4)),
                  GETNEWNAME(&n,plainenv),P_ATA(n,V(4))); 
}
static STATUS hid239(PRECC_DATA* self) {
PARSER hid237;ACTION hid238;
return p_attach0n(self,TOPARSER hid237,0,hid238,0);
}
static STATUS hid240(PRECC_DATA* self) {
PARSER hid239, p_nothing0;
return p_andparse0n (self,TOPARSER hid239,0,TOPARSER p_nothing0,0);
}
static STATUS hid241 (PRECC_DATA* self) {
PARSER hid231, hid240;
return p_orparse0n (self,TOPARSER hid231,0,TOPARSER hid240,0);
}
STATUS bracketresult(PRECC_DATA* self) {
PARSER hid241;
P_RETURN((TOPARSER hid241)(self),"bracketresult");
}


                /* here is one overpull */

int starflag=0;
char *starqual;

/* can't allow "a * n" because it can't be distinguished from "a* b" */

static VOID hid242(PRECC_DATA* self) {
starflag=1;VV(2)=(getname(&V(2)),V(2));
}
static STATUS hid243(PRECC_DATA* self) {
PARSER expr;ACTION hid242;
return p_attach0n(self,TOPARSER expr,0,hid242,0);
}
static STATUS hid244(PRECC_DATA* self) {
PARSER hid243, p_nothing0;
return p_andparse0n (self,TOPARSER hid243,0,TOPARSER p_nothing0,0);
}
static STATUS hid245(PRECC_DATA* self) {
PARSER hid244;
return p_option0n(self,TOPARSER hid244,0);
}
static STATUS hid246(PRECC_DATA* self) {
PARSER STAR, hid245;
return p_andparse0n (self,TOPARSER STAR,0,TOPARSER hid245,0);
}
static VOID hid247(PRECC_DATA* self) {
 char *n;if(starflag){
                  VV(2)=(GETNEWNAME(&n,plainenv),P_ITR(n,V(1),V(3))); 
                  }  else {
                  VV(2)=(GETNEWNAME(&n,plainenv),P_INF(n,V(1)));
                  }  starflag=0; 
}
static STATUS hid248(PRECC_DATA* self) {
PARSER hid246;ACTION hid247;
return p_attach0n(self,TOPARSER hid246,0,hid247,0);
}
static STATUS hid249(PRECC_DATA* self) {
PARSER hid248, p_nothing0;
return p_andparse0n (self,TOPARSER hid248,0,TOPARSER p_nothing0,0);
}
STATUS starop(PRECC_DATA* self) {
PARSER hid249;
P_RETURN((TOPARSER hid249)(self),"starop");
}

static VOID hid250(PRECC_DATA* self) {
 VV(1)="p_anything0"; 
}
static STATUS hid251(PRECC_DATA* self) {
PARSER QUESTION;ACTION hid250;
return p_attach0n(self,TOPARSER QUESTION,0,hid250,0);
}
static STATUS hid252(PRECC_DATA* self) {
PARSER hid251, p_nothing0;
return p_andparse0n (self,TOPARSER hid251,0,TOPARSER p_nothing0,0);
}
STATUS anymatch(PRECC_DATA* self) {
PARSER hid252;
P_RETURN((TOPARSER hid252)(self),"anymatch");
}

/* recall that exprnames get saved in the cbuff */


static STATUS hid253 (PRECC_DATA* self) {
PARSER plingmatch, exprname;
return p_orparse0n (self,TOPARSER plingmatch,0,TOPARSER exprname,0);
}
static STATUS hid254 (PRECC_DATA* self) {
PARSER plingexpr, hid253;
return p_orparse0n (self,TOPARSER plingexpr,0,TOPARSER hid253,0);
}
static STATUS hid255 (PRECC_DATA* self) {
PARSER finishmatch, hid254;
return p_orparse0n (self,TOPARSER finishmatch,0,TOPARSER hid254,0);
}
static STATUS hid256 (PRECC_DATA* self) {
PARSER dollarplingmatch, hid255;
return p_orparse0n (self,TOPARSER dollarplingmatch,0,TOPARSER hid255,0);
}
static STATUS hid257 (PRECC_DATA* self) {
PARSER eofmatch, hid256;
return p_orparse0n (self,TOPARSER eofmatch,0,TOPARSER hid256,0);
}
static STATUS hid258 (PRECC_DATA* self) {
PARSER beginmatch, hid257;
return p_orparse0n (self,TOPARSER beginmatch,0,TOPARSER hid257,0);
}
static STATUS hid259 (PRECC_DATA* self) {
PARSER anymatch, hid258;
return p_orparse0n (self,TOPARSER anymatch,0,TOPARSER hid258,0);
}
static STATUS hid260 (PRECC_DATA* self) {
PARSER result, hid259;
return p_orparse0n (self,TOPARSER result,0,TOPARSER hid259,0);
}
static STATUS hid261 (PRECC_DATA* self) {
PARSER phantom, hid260;
return p_orparse0n (self,TOPARSER phantom,0,TOPARSER hid260,0);
}
static STATUS hid262 (PRECC_DATA* self) {
PARSER test, hid261;
return p_orparse0n (self,TOPARSER test,0,TOPARSER hid261,0);
}
static STATUS hid263 (PRECC_DATA* self) {
PARSER range, hid262;
return p_orparse0n (self,TOPARSER range,0,TOPARSER hid262,0);
}
static STATUS hid264 (PRECC_DATA* self) {
PARSER antiliteral, hid263;
return p_orparse0n (self,TOPARSER antiliteral,0,TOPARSER hid263,0);
}
static STATUS hid265 (PRECC_DATA* self) {
PARSER literal, hid264;
return p_orparse0n (self,TOPARSER literal,0,TOPARSER hid264,0);
}
static STATUS hid266 (PRECC_DATA* self) {
PARSER option, hid265;
return p_orparse0n (self,TOPARSER option,0,TOPARSER hid265,0);
}
static STATUS hid267 (PRECC_DATA* self) {
PARSER bracket, hid266;
return p_orparse0n (self,TOPARSER bracket,0,TOPARSER hid266,0);
}
static STATUS hid268 (PRECC_DATA* self) {
PARSER brackettest, hid267;
return p_orparse0n (self,TOPARSER brackettest,0,TOPARSER hid267,0);
}
static STATUS hid269 (PRECC_DATA* self) {
PARSER bracketresult, hid268;
return p_orparse0n (self,TOPARSER bracketresult,0,TOPARSER hid268,0);
}
static STATUS hid270 (PRECC_DATA* self) {
PARSER bracketcommand, hid269;
return p_orparse0n (self,TOPARSER bracketcommand,0,TOPARSER hid269,0);
}
STATUS seqoperand(PRECC_DATA* self) {
PARSER hid270;
P_RETURN((TOPARSER hid270)(self),"seqoperand");
}


static STATUS hid271(PRECC_DATA* self) {
PARSER PLING, bracket;
return p_andparse0n (self,TOPARSER PLING,0,TOPARSER bracket,0);
}
static VOID hid272(PRECC_DATA* self) {
 char *n;   VV(2)=(GETNEWNAME(&n,plainenv),P_ERR(n,V(2))); 
}
static STATUS hid273(PRECC_DATA* self) {
PARSER hid271;ACTION hid272;
return p_attach0n(self,TOPARSER hid271,0,hid272,0);
}
static STATUS hid274(PRECC_DATA* self) {
PARSER hid273, p_nothing0;
return p_andparse0n (self,TOPARSER hid273,0,TOPARSER p_nothing0,0);
}
STATUS plingexpr(PRECC_DATA* self) {
PARSER hid274;
P_RETURN((TOPARSER hid274)(self),"plingexpr");
}

static STATUS hid275(PRECC_DATA* self) {
PARSER WHITESPACE, OPENBRACKET;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER OPENBRACKET,0);
}
static STATUS hid276(PRECC_DATA* self) {
PARSER expression, hid275;
return p_andparse0n (self,TOPARSER expression,0,TOPARSER hid275,0);
}
static STATUS hid277(PRECC_DATA* self) {
PARSER WHITESPACE, hid276;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid276,0);
}
static STATUS hid278(PRECC_DATA* self) {
PARSER CLOSEBRACKET, hid277;
return p_andparse0n (self,TOPARSER CLOSEBRACKET,0,TOPARSER hid277,0);
}
static VOID hid279(PRECC_DATA* self) {
char *n;VV(5)=(GETNEWNAME(&n,plainenv),P_PHA(n,V(3))); 
}
static STATUS hid280(PRECC_DATA* self) {
PARSER hid278;ACTION hid279;
return p_attach0n(self,TOPARSER hid278,0,hid279,0);
}
static STATUS hid281(PRECC_DATA* self) {
PARSER hid280, p_nothing0;
return p_andparse0n (self,TOPARSER hid280,0,TOPARSER p_nothing0,0);
}
STATUS phantom(PRECC_DATA* self) {
PARSER hid281;
P_RETURN((TOPARSER hid281)(self),"phantom");
}


/* ----------- subtokens of large "tokens" --------------------------- */

/* a literal is anything inside angle brackets.
 * an antiliteral is anything inside anti angle brackets.
 * anglebrackets inside may be escaped to protect them
 */

static VOID hid282(PRECC_DATA* self) {
 VV(1) = putchar(T(1)); 
}
static STATUS hid283(PRECC_DATA* self) {
PARSER NOTARIGHTANGLEBRACKET;ACTION hid282;
return p_attach0n(self,TOPARSER NOTARIGHTANGLEBRACKET,0,hid282,0);
}
static STATUS hid284(PRECC_DATA* self) {
PARSER hid283, p_nothing0;
return p_andparse0n (self,TOPARSER hid283,0,TOPARSER p_nothing0,0);
}
static STATUS hid285 (PRECC_DATA* self) {
PARSER COMMENT, hid284;
return p_orparse0n (self,TOPARSER COMMENT,0,TOPARSER hid284,0);
}
static STATUS hid286 (PRECC_DATA* self) {
PARSER DOLLARID, hid285;
return p_orparse0n (self,TOPARSER DOLLARID,0,TOPARSER hid285,0);
}
static STATUS hid287 (PRECC_DATA* self) {
PARSER CHARCONST, hid286;
return p_orparse0n (self,TOPARSER CHARCONST,0,TOPARSER hid286,0);
}
static STATUS hid288 (PRECC_DATA* self) {
PARSER STRING, hid287;
return p_orparse0n (self,TOPARSER STRING,0,TOPARSER hid287,0);
}
STATUS lstuff(PRECC_DATA* self) {
PARSER hid288;
P_RETURN((TOPARSER hid288)(self),"lstuff");
}

static VOID hid289(PRECC_DATA* self) {
 VV(1) = putchar(T(1)); 
}
static STATUS hid290(PRECC_DATA* self) {
PARSER NOTALEFTANGLEBRACKET;ACTION hid289;
return p_attach0n(self,TOPARSER NOTALEFTANGLEBRACKET,0,hid289,0);
}
static STATUS hid291(PRECC_DATA* self) {
PARSER hid290, p_nothing0;
return p_andparse0n (self,TOPARSER hid290,0,TOPARSER p_nothing0,0);
}
static STATUS hid292 (PRECC_DATA* self) {
PARSER COMMENT, hid291;
return p_orparse0n (self,TOPARSER COMMENT,0,TOPARSER hid291,0);
}
static STATUS hid293 (PRECC_DATA* self) {
PARSER DOLLARID, hid292;
return p_orparse0n (self,TOPARSER DOLLARID,0,TOPARSER hid292,0);
}
static STATUS hid294 (PRECC_DATA* self) {
PARSER CHARCONST, hid293;
return p_orparse0n (self,TOPARSER CHARCONST,0,TOPARSER hid293,0);
}
static STATUS hid295 (PRECC_DATA* self) {
PARSER STRING, hid294;
return p_orparse0n (self,TOPARSER STRING,0,TOPARSER hid294,0);
}
STATUS alstuff(PRECC_DATA* self) {
PARSER hid295;
P_RETURN((TOPARSER hid295)(self),"alstuff");
}

/* anything except (} */

static VOID hid296(PRECC_DATA* self) {
 VV(1) = putchar(T(1)); 
}
static STATUS hid297(PRECC_DATA* self) {
PARSER NOTANOPENPARBRACE;ACTION hid296;
return p_attach0n(self,TOPARSER NOTANOPENPARBRACE,0,hid296,0);
}
static STATUS hid298(PRECC_DATA* self) {
PARSER hid297, p_nothing0;
return p_andparse0n (self,TOPARSER hid297,0,TOPARSER p_nothing0,0);
}
static STATUS hid299 (PRECC_DATA* self) {
PARSER COMMENT, hid298;
return p_orparse0n (self,TOPARSER COMMENT,0,TOPARSER hid298,0);
}
static STATUS hid300 (PRECC_DATA* self) {
PARSER DOLLARID, hid299;
return p_orparse0n (self,TOPARSER DOLLARID,0,TOPARSER hid299,0);
}
static STATUS hid301 (PRECC_DATA* self) {
PARSER CHARCONST, hid300;
return p_orparse0n (self,TOPARSER CHARCONST,0,TOPARSER hid300,0);
}
static STATUS hid302 (PRECC_DATA* self) {
PARSER STRING, hid301;
return p_orparse0n (self,TOPARSER STRING,0,TOPARSER hid301,0);
}
STATUS tlstuff(PRECC_DATA* self) {
PARSER hid302;
P_RETURN((TOPARSER hid302)(self),"tlstuff");
}

/* anything except }( */

static VOID hid303(PRECC_DATA* self) {
 VV(1) = putchar(T(1)); 
}
static STATUS hid304(PRECC_DATA* self) {
PARSER NOTABRACEOPENPAR;ACTION hid303;
return p_attach0n(self,TOPARSER NOTABRACEOPENPAR,0,hid303,0);
}
static STATUS hid305(PRECC_DATA* self) {
PARSER hid304, p_nothing0;
return p_andparse0n (self,TOPARSER hid304,0,TOPARSER p_nothing0,0);
}
static STATUS hid306 (PRECC_DATA* self) {
PARSER COMMENT, hid305;
return p_orparse0n (self,TOPARSER COMMENT,0,TOPARSER hid305,0);
}
static STATUS hid307 (PRECC_DATA* self) {
PARSER DOLLARID, hid306;
return p_orparse0n (self,TOPARSER DOLLARID,0,TOPARSER hid306,0);
}
static STATUS hid308 (PRECC_DATA* self) {
PARSER CHARCONST, hid307;
return p_orparse0n (self,TOPARSER CHARCONST,0,TOPARSER hid307,0);
}
static STATUS hid309 (PRECC_DATA* self) {
PARSER STRING, hid308;
return p_orparse0n (self,TOPARSER STRING,0,TOPARSER hid308,0);
}
STATUS atlstuff(PRECC_DATA* self) {
PARSER hid309;
P_RETURN((TOPARSER hid309)(self),"atlstuff");
}

# define NLCONV(x) ((x)=='\b'?'\n':(x)) /* undo yylex \n->\b conversion */
# define NLCONV(x) ((x)=='\b'?'\n':(x)) /* undo yylex \n->\b conversion */

/* anything except @} */

static VOID hid310(PRECC_DATA* self) {
 VV(1) = putchar(NLCONV(T(1))); 
}
static STATUS hid311(PRECC_DATA* self) {
PARSER NOTANATBRACE;ACTION hid310;
return p_attach0n(self,TOPARSER NOTANATBRACE,0,hid310,0);
}
static STATUS hid312(PRECC_DATA* self) {
PARSER hid311, p_nothing0;
return p_andparse0n (self,TOPARSER hid311,0,TOPARSER p_nothing0,0);
}
static STATUS hid313 (PRECC_DATA* self) {
PARSER COMMENT, hid312;
return p_orparse0n (self,TOPARSER COMMENT,0,TOPARSER hid312,0);
}
static STATUS hid314 (PRECC_DATA* self) {
PARSER DOLLARID, hid313;
return p_orparse0n (self,TOPARSER DOLLARID,0,TOPARSER hid313,0);
}
static STATUS hid315 (PRECC_DATA* self) {
PARSER CHARCONST, hid314;
return p_orparse0n (self,TOPARSER CHARCONST,0,TOPARSER hid314,0);
}
static STATUS hid316 (PRECC_DATA* self) {
PARSER STRING, hid315;
return p_orparse0n (self,TOPARSER STRING,0,TOPARSER hid315,0);
}
STATUS atstuff(PRECC_DATA* self) {
PARSER hid316;
P_RETURN((TOPARSER hid316)(self),"atstuff");
}

/* anything except }@ */

static VOID hid317(PRECC_DATA* self) {
 VV(1) = putchar(NLCONV(T(1))); 
}
static STATUS hid318(PRECC_DATA* self) {
PARSER NOTABRACEAT;ACTION hid317;
return p_attach0n(self,TOPARSER NOTABRACEAT,0,hid317,0);
}
static STATUS hid319(PRECC_DATA* self) {
PARSER hid318, p_nothing0;
return p_andparse0n (self,TOPARSER hid318,0,TOPARSER p_nothing0,0);
}
static STATUS hid320 (PRECC_DATA* self) {
PARSER COMMENT, hid319;
return p_orparse0n (self,TOPARSER COMMENT,0,TOPARSER hid319,0);
}
static STATUS hid321 (PRECC_DATA* self) {
PARSER DOLLARID, hid320;
return p_orparse0n (self,TOPARSER DOLLARID,0,TOPARSER hid320,0);
}
static STATUS hid322 (PRECC_DATA* self) {
PARSER CHARCONST, hid321;
return p_orparse0n (self,TOPARSER CHARCONST,0,TOPARSER hid321,0);
}
static STATUS hid323 (PRECC_DATA* self) {
PARSER STRING, hid322;
return p_orparse0n (self,TOPARSER STRING,0,TOPARSER hid322,0);
}
STATUS aatstuff(PRECC_DATA* self) {
PARSER hid323;
P_RETURN((TOPARSER hid323)(self),"aatstuff");
}

/* anything except : */

static VOID hid324(PRECC_DATA* self) {
 VV(1) = putchar(NLCONV(T(1))); 
}
static STATUS hid325(PRECC_DATA* self) {
PARSER NOTACOLON;ACTION hid324;
return p_attach0n(self,TOPARSER NOTACOLON,0,hid324,0);
}
static STATUS hid326(PRECC_DATA* self) {
PARSER hid325, p_nothing0;
return p_andparse0n (self,TOPARSER hid325,0,TOPARSER p_nothing0,0);
}
static STATUS hid327 (PRECC_DATA* self) {
PARSER COMMENT, hid326;
return p_orparse0n (self,TOPARSER COMMENT,0,TOPARSER hid326,0);
}
static STATUS hid328 (PRECC_DATA* self) {
PARSER DOLLARID, hid327;
return p_orparse0n (self,TOPARSER DOLLARID,0,TOPARSER hid327,0);
}
static STATUS hid329 (PRECC_DATA* self) {
PARSER CHARCONST, hid328;
return p_orparse0n (self,TOPARSER CHARCONST,0,TOPARSER hid328,0);
}
static STATUS hid330 (PRECC_DATA* self) {
PARSER STRING, hid329;
return p_orparse0n (self,TOPARSER STRING,0,TOPARSER hid329,0);
}
STATUS cstuff(PRECC_DATA* self) {
PARSER hid330;
P_RETURN((TOPARSER hid330)(self),"cstuff");
}

/* anything except :} */

static VOID hid331(PRECC_DATA* self) {
 VV(1) = putchar(NLCONV(T(1))); 
}
static STATUS hid332(PRECC_DATA* self) {
PARSER NOTACOLONBRACE;ACTION hid331;
return p_attach0n(self,TOPARSER NOTACOLONBRACE,0,hid331,0);
}
static STATUS hid333(PRECC_DATA* self) {
PARSER hid332, p_nothing0;
return p_andparse0n (self,TOPARSER hid332,0,TOPARSER p_nothing0,0);
}
static STATUS hid334 (PRECC_DATA* self) {
PARSER COMMENT, hid333;
return p_orparse0n (self,TOPARSER COMMENT,0,TOPARSER hid333,0);
}
static STATUS hid335 (PRECC_DATA* self) {
PARSER DOLLARID, hid334;
return p_orparse0n (self,TOPARSER DOLLARID,0,TOPARSER hid334,0);
}
static STATUS hid336 (PRECC_DATA* self) {
PARSER CHARCONST, hid335;
return p_orparse0n (self,TOPARSER CHARCONST,0,TOPARSER hid335,0);
}
static STATUS hid337 (PRECC_DATA* self) {
PARSER STRING, hid336;
return p_orparse0n (self,TOPARSER STRING,0,TOPARSER hid336,0);
}
STATUS cstuff1(PRECC_DATA* self) {
PARSER hid337;
P_RETURN((TOPARSER hid337)(self),"cstuff1");
}

/* anything except }: */

static VOID hid338(PRECC_DATA* self) {
 VV(1) = putchar(NLCONV(T(1))); 
}
static STATUS hid339(PRECC_DATA* self) {
PARSER NOTABRACECOLON;ACTION hid338;
return p_attach0n(self,TOPARSER NOTABRACECOLON,0,hid338,0);
}
static STATUS hid340(PRECC_DATA* self) {
PARSER hid339, p_nothing0;
return p_andparse0n (self,TOPARSER hid339,0,TOPARSER p_nothing0,0);
}
static STATUS hid341 (PRECC_DATA* self) {
PARSER COMMENT, hid340;
return p_orparse0n (self,TOPARSER COMMENT,0,TOPARSER hid340,0);
}
static STATUS hid342 (PRECC_DATA* self) {
PARSER DOLLARID, hid341;
return p_orparse0n (self,TOPARSER DOLLARID,0,TOPARSER hid341,0);
}
static STATUS hid343 (PRECC_DATA* self) {
PARSER CHARCONST, hid342;
return p_orparse0n (self,TOPARSER CHARCONST,0,TOPARSER hid342,0);
}
static STATUS hid344 (PRECC_DATA* self) {
PARSER STRING, hid343;
return p_orparse0n (self,TOPARSER STRING,0,TOPARSER hid343,0);
}
STATUS cstuff2(PRECC_DATA* self) {
PARSER hid344;
P_RETURN((TOPARSER hid344)(self),"cstuff2");
}

/* -------------------------------------------------------------------- */


/* ------- let a stream flow by, while engraving itself in cbuff ------ */

static VOID hid345(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid346(PRECC_DATA* self) {
PARSER atstuff;ACTION hid345;
return p_attach0n(self,TOPARSER atstuff,0,hid345,0);
}
static STATUS hid347(PRECC_DATA* self) {
PARSER hid346, p_nothing0;
return p_andparse0n (self,TOPARSER hid346,0,TOPARSER p_nothing0,0);
}
static STATUS hid348(PRECC_DATA* self) {
PARSER hid347;
return p_many0n(self,TOPARSER hid347,0);
}
static STATUS hid349(PRECC_DATA* self) {
PARSER atstuff, hid348;
return p_andparse0n (self,TOPARSER atstuff,0,TOPARSER hid348,0);
}
static VOID hid350(PRECC_DATA* self) {
 VV(0) =""; 
}
static STATUS hid351(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid350;
return p_attach0n(self,TOPARSER p_nothing0,0,hid350,0);
}
static STATUS hid352(PRECC_DATA* self) {
PARSER hid351, p_nothing0;
return p_andparse0n (self,TOPARSER hid351,0,TOPARSER p_nothing0,0);
}
static STATUS hid353 (PRECC_DATA* self) {
PARSER hid349, hid352;
return p_orparse0n (self,TOPARSER hid349,0,TOPARSER hid352,0);
}
STATUS atstuffs(PRECC_DATA* self) {
PARSER hid353;
P_RETURN((TOPARSER hid353)(self),"atstuffs");
}

static VOID hid354(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid355(PRECC_DATA* self) {
PARSER aatstuff;ACTION hid354;
return p_attach0n(self,TOPARSER aatstuff,0,hid354,0);
}
static STATUS hid356(PRECC_DATA* self) {
PARSER hid355, p_nothing0;
return p_andparse0n (self,TOPARSER hid355,0,TOPARSER p_nothing0,0);
}
static STATUS hid357(PRECC_DATA* self) {
PARSER hid356;
return p_many0n(self,TOPARSER hid356,0);
}
static STATUS hid358(PRECC_DATA* self) {
PARSER aatstuff, hid357;
return p_andparse0n (self,TOPARSER aatstuff,0,TOPARSER hid357,0);
}
static VOID hid359(PRECC_DATA* self) {
 VV(0) =""; 
}
static STATUS hid360(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid359;
return p_attach0n(self,TOPARSER p_nothing0,0,hid359,0);
}
static STATUS hid361(PRECC_DATA* self) {
PARSER hid360, p_nothing0;
return p_andparse0n (self,TOPARSER hid360,0,TOPARSER p_nothing0,0);
}
static STATUS hid362 (PRECC_DATA* self) {
PARSER hid358, hid361;
return p_orparse0n (self,TOPARSER hid358,0,TOPARSER hid361,0);
}
STATUS aatstuffs(PRECC_DATA* self) {
PARSER hid362;
P_RETURN((TOPARSER hid362)(self),"aatstuffs");
}

static VOID hid363(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid364(PRECC_DATA* self) {
PARSER lstuff;ACTION hid363;
return p_attach0n(self,TOPARSER lstuff,0,hid363,0);
}
static STATUS hid365(PRECC_DATA* self) {
PARSER hid364, p_nothing0;
return p_andparse0n (self,TOPARSER hid364,0,TOPARSER p_nothing0,0);
}
static STATUS hid366(PRECC_DATA* self) {
PARSER hid365;
return p_many0n(self,TOPARSER hid365,0);
}
static STATUS hid367(PRECC_DATA* self) {
PARSER lstuff, hid366;
return p_andparse0n (self,TOPARSER lstuff,0,TOPARSER hid366,0);
}
static VOID hid368(PRECC_DATA* self) {
 VV(0)=""; 
}
static STATUS hid369(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid368;
return p_attach0n(self,TOPARSER p_nothing0,0,hid368,0);
}
static STATUS hid370(PRECC_DATA* self) {
PARSER hid369, p_nothing0;
return p_andparse0n (self,TOPARSER hid369,0,TOPARSER p_nothing0,0);
}
static STATUS hid371 (PRECC_DATA* self) {
PARSER hid367, hid370;
return p_orparse0n (self,TOPARSER hid367,0,TOPARSER hid370,0);
}
STATUS lstuffs(PRECC_DATA* self) {
PARSER hid371;
P_RETURN((TOPARSER hid371)(self),"lstuffs");
}

static VOID hid372(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid373(PRECC_DATA* self) {
PARSER alstuff;ACTION hid372;
return p_attach0n(self,TOPARSER alstuff,0,hid372,0);
}
static STATUS hid374(PRECC_DATA* self) {
PARSER hid373, p_nothing0;
return p_andparse0n (self,TOPARSER hid373,0,TOPARSER p_nothing0,0);
}
static STATUS hid375(PRECC_DATA* self) {
PARSER hid374;
return p_many0n(self,TOPARSER hid374,0);
}
static STATUS hid376(PRECC_DATA* self) {
PARSER alstuff, hid375;
return p_andparse0n (self,TOPARSER alstuff,0,TOPARSER hid375,0);
}
static VOID hid377(PRECC_DATA* self) {
 VV(0)=""; 
}
static STATUS hid378(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid377;
return p_attach0n(self,TOPARSER p_nothing0,0,hid377,0);
}
static STATUS hid379(PRECC_DATA* self) {
PARSER hid378, p_nothing0;
return p_andparse0n (self,TOPARSER hid378,0,TOPARSER p_nothing0,0);
}
static STATUS hid380 (PRECC_DATA* self) {
PARSER hid376, hid379;
return p_orparse0n (self,TOPARSER hid376,0,TOPARSER hid379,0);
}
STATUS alstuffs(PRECC_DATA* self) {
PARSER hid380;
P_RETURN((TOPARSER hid380)(self),"alstuffs");
}

/* stuff inside a test can be anything except (} */

static VOID hid381(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid382(PRECC_DATA* self) {
PARSER tlstuff;ACTION hid381;
return p_attach0n(self,TOPARSER tlstuff,0,hid381,0);
}
static STATUS hid383(PRECC_DATA* self) {
PARSER hid382, p_nothing0;
return p_andparse0n (self,TOPARSER hid382,0,TOPARSER p_nothing0,0);
}
static STATUS hid384(PRECC_DATA* self) {
PARSER hid383;
return p_many0n(self,TOPARSER hid383,0);
}
static STATUS hid385(PRECC_DATA* self) {
PARSER tlstuff, hid384;
return p_andparse0n (self,TOPARSER tlstuff,0,TOPARSER hid384,0);
}
static VOID hid386(PRECC_DATA* self) {
 VV(0)=""; 
}
static STATUS hid387(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid386;
return p_attach0n(self,TOPARSER p_nothing0,0,hid386,0);
}
static STATUS hid388(PRECC_DATA* self) {
PARSER hid387, p_nothing0;
return p_andparse0n (self,TOPARSER hid387,0,TOPARSER p_nothing0,0);
}
static STATUS hid389 (PRECC_DATA* self) {
PARSER hid385, hid388;
return p_orparse0n (self,TOPARSER hid385,0,TOPARSER hid388,0);
}
STATUS tlstuffs(PRECC_DATA* self) {
PARSER hid389;
P_RETURN((TOPARSER hid389)(self),"tlstuffs");
}

/* stuff inside a test can be anything except }( */

static VOID hid390(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid391(PRECC_DATA* self) {
PARSER atlstuff;ACTION hid390;
return p_attach0n(self,TOPARSER atlstuff,0,hid390,0);
}
static STATUS hid392(PRECC_DATA* self) {
PARSER hid391, p_nothing0;
return p_andparse0n (self,TOPARSER hid391,0,TOPARSER p_nothing0,0);
}
static STATUS hid393(PRECC_DATA* self) {
PARSER hid392;
return p_many0n(self,TOPARSER hid392,0);
}
static STATUS hid394(PRECC_DATA* self) {
PARSER atlstuff, hid393;
return p_andparse0n (self,TOPARSER atlstuff,0,TOPARSER hid393,0);
}
static VOID hid395(PRECC_DATA* self) {
 VV(0)=""; 
}
static STATUS hid396(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid395;
return p_attach0n(self,TOPARSER p_nothing0,0,hid395,0);
}
static STATUS hid397(PRECC_DATA* self) {
PARSER hid396, p_nothing0;
return p_andparse0n (self,TOPARSER hid396,0,TOPARSER p_nothing0,0);
}
static STATUS hid398 (PRECC_DATA* self) {
PARSER hid394, hid397;
return p_orparse0n (self,TOPARSER hid394,0,TOPARSER hid397,0);
}
STATUS atlstuffs(PRECC_DATA* self) {
PARSER hid398;
P_RETURN((TOPARSER hid398)(self),"atlstuffs");
}

/* the stuff inside a command is a sequence of C constants or C tokens */

static VOID hid399(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid400(PRECC_DATA* self) {
PARSER cstuff;ACTION hid399;
return p_attach0n(self,TOPARSER cstuff,0,hid399,0);
}
static STATUS hid401(PRECC_DATA* self) {
PARSER hid400, p_nothing0;
return p_andparse0n (self,TOPARSER hid400,0,TOPARSER p_nothing0,0);
}
static STATUS hid402(PRECC_DATA* self) {
PARSER hid401;
return p_many0n(self,TOPARSER hid401,0);
}
static STATUS hid403(PRECC_DATA* self) {
PARSER cstuff, hid402;
return p_andparse0n (self,TOPARSER cstuff,0,TOPARSER hid402,0);
}
static VOID hid404(PRECC_DATA* self) {
 VV(0) =""; 
}
static STATUS hid405(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid404;
return p_attach0n(self,TOPARSER p_nothing0,0,hid404,0);
}
static STATUS hid406(PRECC_DATA* self) {
PARSER hid405, p_nothing0;
return p_andparse0n (self,TOPARSER hid405,0,TOPARSER p_nothing0,0);
}
static STATUS hid407 (PRECC_DATA* self) {
PARSER hid403, hid406;
return p_orparse0n (self,TOPARSER hid403,0,TOPARSER hid406,0);
}
STATUS cstuffs(PRECC_DATA* self) {
PARSER hid407;
P_RETURN((TOPARSER hid407)(self),"cstuffs");
}

/* this kind of interior of a command ends only at a :} */

static VOID hid408(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid409(PRECC_DATA* self) {
PARSER cstuff1;ACTION hid408;
return p_attach0n(self,TOPARSER cstuff1,0,hid408,0);
}
static STATUS hid410(PRECC_DATA* self) {
PARSER hid409, p_nothing0;
return p_andparse0n (self,TOPARSER hid409,0,TOPARSER p_nothing0,0);
}
static STATUS hid411(PRECC_DATA* self) {
PARSER hid410;
return p_many0n(self,TOPARSER hid410,0);
}
static STATUS hid412(PRECC_DATA* self) {
PARSER cstuff1, hid411;
return p_andparse0n (self,TOPARSER cstuff1,0,TOPARSER hid411,0);
}
static VOID hid413(PRECC_DATA* self) {
 VV(0) =""; 
}
static STATUS hid414(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid413;
return p_attach0n(self,TOPARSER p_nothing0,0,hid413,0);
}
static STATUS hid415(PRECC_DATA* self) {
PARSER hid414, p_nothing0;
return p_andparse0n (self,TOPARSER hid414,0,TOPARSER p_nothing0,0);
}
static STATUS hid416 (PRECC_DATA* self) {
PARSER hid412, hid415;
return p_orparse0n (self,TOPARSER hid412,0,TOPARSER hid415,0);
}
STATUS cstuffs1(PRECC_DATA* self) {
PARSER hid416;
P_RETURN((TOPARSER hid416)(self),"cstuffs1");
}

/* this kind of interior of a command ends only at a }: */

static VOID hid417(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid418(PRECC_DATA* self) {
PARSER cstuff2;ACTION hid417;
return p_attach0n(self,TOPARSER cstuff2,0,hid417,0);
}
static STATUS hid419(PRECC_DATA* self) {
PARSER hid418, p_nothing0;
return p_andparse0n (self,TOPARSER hid418,0,TOPARSER p_nothing0,0);
}
static STATUS hid420(PRECC_DATA* self) {
PARSER hid419;
return p_many0n(self,TOPARSER hid419,0);
}
static STATUS hid421(PRECC_DATA* self) {
PARSER cstuff2, hid420;
return p_andparse0n (self,TOPARSER cstuff2,0,TOPARSER hid420,0);
}
static VOID hid422(PRECC_DATA* self) {
 VV(0) =""; 
}
static STATUS hid423(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid422;
return p_attach0n(self,TOPARSER p_nothing0,0,hid422,0);
}
static STATUS hid424(PRECC_DATA* self) {
PARSER hid423, p_nothing0;
return p_andparse0n (self,TOPARSER hid423,0,TOPARSER p_nothing0,0);
}
static STATUS hid425 (PRECC_DATA* self) {
PARSER hid421, hid424;
return p_orparse0n (self,TOPARSER hid421,0,TOPARSER hid424,0);
}
STATUS cstuffs2(PRECC_DATA* self) {
PARSER hid425;
P_RETURN((TOPARSER hid425)(self),"cstuffs2");
}

/* ------------------------------------------------------------------- */



/* ------------- close the cbuff accumulator  ------------------------ */

static VOID hid426(PRECC_DATA* self) {
VV(1)=V(1);getname(&V(1));
}
static STATUS hid427(PRECC_DATA* self) {
PARSER lstuffs;ACTION hid426;
return p_attach0n(self,TOPARSER lstuffs,0,hid426,0);
}
static STATUS hid428(PRECC_DATA* self) {
PARSER hid427, p_nothing0;
return p_andparse0n (self,TOPARSER hid427,0,TOPARSER p_nothing0,0);
}
STATUS lits(PRECC_DATA* self) {
PARSER hid428;
P_RETURN((TOPARSER hid428)(self),"lits");
}

static VOID hid429(PRECC_DATA* self) {
VV(1)=V(1);getname(&V(1));
}
static STATUS hid430(PRECC_DATA* self) {
PARSER alstuffs;ACTION hid429;
return p_attach0n(self,TOPARSER alstuffs,0,hid429,0);
}
static STATUS hid431(PRECC_DATA* self) {
PARSER hid430, p_nothing0;
return p_andparse0n (self,TOPARSER hid430,0,TOPARSER p_nothing0,0);
}
STATUS alits(PRECC_DATA* self) {
PARSER hid431;
P_RETURN((TOPARSER hid431)(self),"alits");
}

static VOID hid432(PRECC_DATA* self) {
VV(1)=V(1);getname(&V(1));
}
static STATUS hid433(PRECC_DATA* self) {
PARSER tlstuffs;ACTION hid432;
return p_attach0n(self,TOPARSER tlstuffs,0,hid432,0);
}
static STATUS hid434(PRECC_DATA* self) {
PARSER hid433, p_nothing0;
return p_andparse0n (self,TOPARSER hid433,0,TOPARSER p_nothing0,0);
}
STATUS tlits(PRECC_DATA* self) {
PARSER hid434;
P_RETURN((TOPARSER hid434)(self),"tlits");
}

static VOID hid435(PRECC_DATA* self) {
VV(1)=V(1);getname(&V(1));
}
static STATUS hid436(PRECC_DATA* self) {
PARSER atlstuffs;ACTION hid435;
return p_attach0n(self,TOPARSER atlstuffs,0,hid435,0);
}
static STATUS hid437(PRECC_DATA* self) {
PARSER hid436, p_nothing0;
return p_andparse0n (self,TOPARSER hid436,0,TOPARSER p_nothing0,0);
}
STATUS atlits(PRECC_DATA* self) {
PARSER hid437;
P_RETURN((TOPARSER hid437)(self),"atlits");
}

/* commands didn't use to be able to be treated as ordinary atoms, because they
 * were required to end a sequence of 'and's and force a stack shift */

static VOID hid438(PRECC_DATA* self) {
 VV(1)=V(1); getname(&V(1)); 
}
static STATUS hid439(PRECC_DATA* self) {
PARSER cstuffs;ACTION hid438;
return p_attach0n(self,TOPARSER cstuffs,0,hid438,0);
}
static STATUS hid440(PRECC_DATA* self) {
PARSER hid439, p_nothing0;
return p_andparse0n (self,TOPARSER hid439,0,TOPARSER p_nothing0,0);
}
STATUS c_code(PRECC_DATA* self) {
PARSER hid440;
P_RETURN((TOPARSER hid440)(self),"c_code");
}

/* otoh, this kind of command is an atom - it has code inside {: :} pairs */

static VOID hid441(PRECC_DATA* self) {
 VV(1)=V(1); getname(&V(1)); 
}
static STATUS hid442(PRECC_DATA* self) {
PARSER cstuffs1;ACTION hid441;
return p_attach0n(self,TOPARSER cstuffs1,0,hid441,0);
}
static STATUS hid443(PRECC_DATA* self) {
PARSER hid442, p_nothing0;
return p_andparse0n (self,TOPARSER hid442,0,TOPARSER p_nothing0,0);
}
STATUS c_code1(PRECC_DATA* self) {
PARSER hid443;
P_RETURN((TOPARSER hid443)(self),"c_code1");
}

/* or :{ }: pairs */

static VOID hid444(PRECC_DATA* self) {
 VV(1)=V(1); getname(&V(1)); 
}
static STATUS hid445(PRECC_DATA* self) {
PARSER cstuffs2;ACTION hid444;
return p_attach0n(self,TOPARSER cstuffs2,0,hid444,0);
}
static STATUS hid446(PRECC_DATA* self) {
PARSER hid445, p_nothing0;
return p_andparse0n (self,TOPARSER hid445,0,TOPARSER p_nothing0,0);
}
STATUS c_code2(PRECC_DATA* self) {
PARSER hid446;
P_RETURN((TOPARSER hid446)(self),"c_code2");
}

/* ------------------------------------------------------------------- */


/* ---------------------- large "tokens" ----------------------------- */

static STATUS hid447(PRECC_DATA* self) {
PARSER lits, RIGHTANGLEBRACKET;
return p_andparse0n (self,TOPARSER lits,0,TOPARSER RIGHTANGLEBRACKET,0);
}
static STATUS hid448(PRECC_DATA* self) {
PARSER LEFTANGLEBRACKET, hid447;
return p_andparse0n (self,TOPARSER LEFTANGLEBRACKET,0,TOPARSER hid447,0);
}
static VOID hid449(PRECC_DATA* self) {
 VV(3) = V(2); 
}
static STATUS hid450(PRECC_DATA* self) {
PARSER hid448;ACTION hid449;
return p_attach0n(self,TOPARSER hid448,0,hid449,0);
}
static STATUS hid451(PRECC_DATA* self) {
PARSER hid450, p_nothing0;
return p_andparse0n (self,TOPARSER hid450,0,TOPARSER p_nothing0,0);
}
STATUS LITERAL(PRECC_DATA* self) {
PARSER hid451;
P_RETURN((TOPARSER hid451)(self),"LITERAL");
}

static STATUS hid452(PRECC_DATA* self) {
PARSER alits, LEFTANGLEBRACKET;
return p_andparse0n (self,TOPARSER alits,0,TOPARSER LEFTANGLEBRACKET,0);
}
static STATUS hid453(PRECC_DATA* self) {
PARSER RIGHTANGLEBRACKET, hid452;
return p_andparse0n (self,TOPARSER RIGHTANGLEBRACKET,0,TOPARSER hid452,0);
}
static VOID hid454(PRECC_DATA* self) {
 VV(3) = V(2) ; 
}
static STATUS hid455(PRECC_DATA* self) {
PARSER hid453;ACTION hid454;
return p_attach0n(self,TOPARSER hid453,0,hid454,0);
}
static STATUS hid456(PRECC_DATA* self) {
PARSER hid455, p_nothing0;
return p_andparse0n (self,TOPARSER hid455,0,TOPARSER p_nothing0,0);
}
STATUS ANTILITERAL(PRECC_DATA* self) {
PARSER hid456;
P_RETURN((TOPARSER hid456)(self),"ANTILITERAL");
}

/* ------------------------------------------------------------------- */


static VOID hid457(PRECC_DATA* self) {
char *n;VV(1)=(GETNEWNAME(&n,plainenv),P_LIT(n,V(1))); 
}
static STATUS hid458(PRECC_DATA* self) {
PARSER LITERAL;ACTION hid457;
return p_attach0n(self,TOPARSER LITERAL,0,hid457,0);
}
static STATUS hid459(PRECC_DATA* self) {
PARSER hid458, p_nothing0;
return p_andparse0n (self,TOPARSER hid458,0,TOPARSER p_nothing0,0);
}
STATUS literal(PRECC_DATA* self) {
PARSER hid459;
P_RETURN((TOPARSER hid459)(self),"literal");
}

static VOID hid460(PRECC_DATA* self) {
char *n;VV(1)=(GETNEWNAME(&n,plainenv),P_ALI(n,V(1))); 
}
static STATUS hid461(PRECC_DATA* self) {
PARSER ANTILITERAL;ACTION hid460;
return p_attach0n(self,TOPARSER ANTILITERAL,0,hid460,0);
}
static STATUS hid462(PRECC_DATA* self) {
PARSER hid461, p_nothing0;
return p_andparse0n (self,TOPARSER hid461,0,TOPARSER p_nothing0,0);
}
STATUS antiliteral(PRECC_DATA* self) {
PARSER hid462;
P_RETURN((TOPARSER hid462)(self),"antiliteral");
}

static STATUS hid463(PRECC_DATA* self) {
PARSER WHITESPACE, CLOSEPAREN;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER CLOSEPAREN,0);
}
static STATUS hid464(PRECC_DATA* self) {
PARSER expr, hid463;
return p_andparse0n (self,TOPARSER expr,0,TOPARSER hid463,0);
}
static STATUS hid465(PRECC_DATA* self) {
PARSER WHITESPACE, hid464;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid464,0);
}
static STATUS hid466(PRECC_DATA* self) {
PARSER OPENPAREN, hid465;
return p_andparse0n (self,TOPARSER OPENPAREN,0,TOPARSER hid465,0);
}
static VOID hid467(PRECC_DATA* self) {
char *n;VV(5)=(getname(&V(3)),GETNEWNAME(&n,plainenv),P_RAN(n,V(3)));
}
static STATUS hid468(PRECC_DATA* self) {
PARSER hid466;ACTION hid467;
return p_attach0n(self,TOPARSER hid466,0,hid467,0);
}
static STATUS hid469(PRECC_DATA* self) {
PARSER hid468, p_nothing0;
return p_andparse0n (self,TOPARSER hid468,0,TOPARSER p_nothing0,0);
}
STATUS range(PRECC_DATA* self) {
PARSER hid469;
P_RETURN((TOPARSER hid469)(self),"range");
}

static STATUS hid470(PRECC_DATA* self) {
PARSER WHITESPACE, OPENPAREN;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER OPENPAREN,0);
}
static STATUS hid471(PRECC_DATA* self) {
PARSER expr, hid470;
return p_andparse0n (self,TOPARSER expr,0,TOPARSER hid470,0);
}
static STATUS hid472(PRECC_DATA* self) {
PARSER WHITESPACE, hid471;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid471,0);
}
static STATUS hid473(PRECC_DATA* self) {
PARSER CLOSEPAREN, hid472;
return p_andparse0n (self,TOPARSER CLOSEPAREN,0,TOPARSER hid472,0);
}
static VOID hid474(PRECC_DATA* self) {
char *n;VV(5)=(getname(&V(3)),GETNEWNAME(&n,plainenv),P_TST(n,V(3)));
}
static STATUS hid475(PRECC_DATA* self) {
PARSER hid473;ACTION hid474;
return p_attach0n(self,TOPARSER hid473,0,hid474,0);
}
static STATUS hid476(PRECC_DATA* self) {
PARSER hid475, p_nothing0;
return p_andparse0n (self,TOPARSER hid475,0,TOPARSER p_nothing0,0);
}
STATUS test(PRECC_DATA* self) {
PARSER hid476;
P_RETURN((TOPARSER hid476)(self),"test");
}

static STATUS hid477(PRECC_DATA* self) {
PARSER OPENPAREN, CLOSEBRACE;
return p_andparse0n (self,TOPARSER OPENPAREN,0,TOPARSER CLOSEBRACE,0);
}
static STATUS hid478(PRECC_DATA* self) {
PARSER WHITESPACE, hid477;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid477,0);
}
static STATUS hid479(PRECC_DATA* self) {
PARSER tlits, hid478;
return p_andparse0n (self,TOPARSER tlits,0,TOPARSER hid478,0);
}
static STATUS hid480(PRECC_DATA* self) {
PARSER WHITESPACE, hid479;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid479,0);
}
static STATUS hid481(PRECC_DATA* self) {
PARSER CLOSEPAREN, hid480;
return p_andparse0n (self,TOPARSER CLOSEPAREN,0,TOPARSER hid480,0);
}
static STATUS hid482(PRECC_DATA* self) {
PARSER OPENBRACE, hid481;
return p_andparse0n (self,TOPARSER OPENBRACE,0,TOPARSER hid481,0);
}
static VOID hid483(PRECC_DATA* self) {
char *n;VV(7)=(GETNEWNAME(&n,plainenv),P_TST(n,V(4))); 
}
static STATUS hid484(PRECC_DATA* self) {
PARSER hid482;ACTION hid483;
return p_attach0n(self,TOPARSER hid482,0,hid483,0);
}
static STATUS hid485(PRECC_DATA* self) {
PARSER hid484, p_nothing0;
return p_andparse0n (self,TOPARSER hid484,0,TOPARSER p_nothing0,0);
}
static STATUS hid486(PRECC_DATA* self) {
PARSER CLOSEBRACE, OPENPAREN;
return p_andparse0n (self,TOPARSER CLOSEBRACE,0,TOPARSER OPENPAREN,0);
}
static STATUS hid487(PRECC_DATA* self) {
PARSER WHITESPACE, hid486;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid486,0);
}
static STATUS hid488(PRECC_DATA* self) {
PARSER atlits, hid487;
return p_andparse0n (self,TOPARSER atlits,0,TOPARSER hid487,0);
}
static STATUS hid489(PRECC_DATA* self) {
PARSER WHITESPACE, hid488;
return p_andparse0n (self,TOPARSER WHITESPACE,0,TOPARSER hid488,0);
}
static STATUS hid490(PRECC_DATA* self) {
PARSER OPENBRACE, hid489;
return p_andparse0n (self,TOPARSER OPENBRACE,0,TOPARSER hid489,0);
}
static STATUS hid491(PRECC_DATA* self) {
PARSER CLOSEPAREN, hid490;
return p_andparse0n (self,TOPARSER CLOSEPAREN,0,TOPARSER hid490,0);
}
static VOID hid492(PRECC_DATA* self) {
char *n;VV(7)=(GETNEWNAME(&n,plainenv),P_TST(n,V(4))); 
}
static STATUS hid493(PRECC_DATA* self) {
PARSER hid491;ACTION hid492;
return p_attach0n(self,TOPARSER hid491,0,hid492,0);
}
static STATUS hid494(PRECC_DATA* self) {
PARSER hid493, p_nothing0;
return p_andparse0n (self,TOPARSER hid493,0,TOPARSER p_nothing0,0);
}
static STATUS hid495 (PRECC_DATA* self) {
PARSER hid485, hid494;
return p_orparse0n (self,TOPARSER hid485,0,TOPARSER hid494,0);
}
STATUS brackettest(PRECC_DATA* self) {
PARSER hid495;
P_RETURN((TOPARSER hid495)(self),"brackettest");
}

static VOID hid496(PRECC_DATA* self) {
 VV(1)="p_first0"; 
}
static STATUS hid497(PRECC_DATA* self) {
PARSER CARET;ACTION hid496;
return p_attach0n(self,TOPARSER CARET,0,hid496,0);
}
static STATUS hid498(PRECC_DATA* self) {
PARSER hid497, p_nothing0;
return p_andparse0n (self,TOPARSER hid497,0,TOPARSER p_nothing0,0);
}
STATUS beginmatch(PRECC_DATA* self) {
PARSER hid498;
P_RETURN((TOPARSER hid498)(self),"beginmatch");
}

static VOID hid499(PRECC_DATA* self) {
 VV(1)="p_last0"; 
}
static STATUS hid500(PRECC_DATA* self) {
PARSER DOLLAR;ACTION hid499;
return p_attach0n(self,TOPARSER DOLLAR,0,hid499,0);
}
static STATUS hid501(PRECC_DATA* self) {
PARSER hid500, p_nothing0;
return p_andparse0n (self,TOPARSER hid500,0,TOPARSER p_nothing0,0);
}
STATUS finishmatch(PRECC_DATA* self) {
PARSER hid501;
P_RETURN((TOPARSER hid501)(self),"finishmatch");
}

static VOID hid502(PRECC_DATA* self) {
 VV(1)="p_uniq0"; 
}
static STATUS hid503(PRECC_DATA* self) {
PARSER PLING;ACTION hid502;
return p_attach0n(self,TOPARSER PLING,0,hid502,0);
}
static STATUS hid504(PRECC_DATA* self) {
PARSER hid503, p_nothing0;
return p_andparse0n (self,TOPARSER hid503,0,TOPARSER p_nothing0,0);
}
STATUS plingmatch(PRECC_DATA* self) {
PARSER hid504;
P_RETURN((TOPARSER hid504)(self),"plingmatch");
}

static STATUS hid505(PRECC_DATA* self) {
PARSER DOLLAR, PLING;
return p_andparse0n (self,TOPARSER DOLLAR,0,TOPARSER PLING,0);
}
static VOID hid506(PRECC_DATA* self) {
 VV(2)="p_lastuniq0"; 
}
static STATUS hid507(PRECC_DATA* self) {
PARSER hid505;ACTION hid506;
return p_attach0n(self,TOPARSER hid505,0,hid506,0);
}
static STATUS hid508(PRECC_DATA* self) {
PARSER hid507, p_nothing0;
return p_andparse0n (self,TOPARSER hid507,0,TOPARSER p_nothing0,0);
}
STATUS dollarplingmatch(PRECC_DATA* self) {
PARSER hid508;
P_RETURN((TOPARSER hid508)(self),"dollarplingmatch");
}

static STATUS hid509(PRECC_DATA* self) {
PARSER DOLLAR, DOLLAR;
return p_andparse0n (self,TOPARSER DOLLAR,0,TOPARSER DOLLAR,0);
}
static VOID hid510(PRECC_DATA* self) {
 VV(2)="p_eof0"; 
}
static STATUS hid511(PRECC_DATA* self) {
PARSER hid509;ACTION hid510;
return p_attach0n(self,TOPARSER hid509,0,hid510,0);
}
static STATUS hid512(PRECC_DATA* self) {
PARSER hid511, p_nothing0;
return p_andparse0n (self,TOPARSER hid511,0,TOPARSER p_nothing0,0);
}
STATUS eofmatch(PRECC_DATA* self) {
PARSER hid512;
P_RETURN((TOPARSER hid512)(self),"eofmatch");
}

                /* another overpull */

static VOID hid513(PRECC_DATA* self) {
 char *n;VV(2)=(GETNEWNAME(&n,plainenv),P_SOM(n,V(1))); 
}
static STATUS hid514(PRECC_DATA* self) {
PARSER PLUS;ACTION hid513;
return p_attach0n(self,TOPARSER PLUS,0,hid513,0);
}
static STATUS hid515(PRECC_DATA* self) {
PARSER hid514, p_nothing0;
return p_andparse0n (self,TOPARSER hid514,0,TOPARSER p_nothing0,0);
}
STATUS plusop(PRECC_DATA* self) {
PARSER hid515;
P_RETURN((TOPARSER hid515)(self),"plusop");
}

static STATUS hid516(PRECC_DATA* self) {
PARSER expr, CLOSEPAREN;
return p_andparse0n (self,TOPARSER expr,0,TOPARSER CLOSEPAREN,0);
}
static STATUS hid517(PRECC_DATA* self) {
PARSER OPENPAREN, hid516;
return p_andparse0n (self,TOPARSER OPENPAREN,0,TOPARSER hid516,0);
}
static STATUS hid518(PRECC_DATA* self) {
PARSER SLASH, hid517;
return p_andparse0n (self,TOPARSER SLASH,0,TOPARSER hid517,0);
}
static VOID hid519(PRECC_DATA* self) {
char *n;
   VV(5)=(getname(&V(4)),GETNEWNAME(&n,plainenv),P_HID(n,V(1),V(4)));
}
static STATUS hid520(PRECC_DATA* self) {
PARSER hid518;ACTION hid519;
return p_attach0n(self,TOPARSER hid518,0,hid519,0);
}
static STATUS hid521(PRECC_DATA* self) {
PARSER hid520, p_nothing0;
return p_andparse0n (self,TOPARSER hid520,0,TOPARSER p_nothing0,0);
}
STATUS hideop(PRECC_DATA* self) {
PARSER hid521;
P_RETURN((TOPARSER hid521)(self),"hideop");
}


                /* ------- finis -------- */

MAIN(line)










